C higgs.f 
C The program speaks for itself. For a given energy, collider and Higgs
C we can plot the total cross section. The program is set up
C in such a way that in each order i.e. LO, NLO and NNLO the correct
C parton density with the corresponding alpha_s, \Lambda and coefficient
C function are called. All parton densities are mrst in LO, NLO and NNLO.
C In the higgs.dat file choose
C MODH=1 scalar Higgs, MODH=2 pseudoscalar higgs with cotan(beta)=1.0 
C MODP=1 proton-proton MODP=2 proton-antiproton
C SS=14000 for LHC  SS=2000 for Tevatron
C The names of the output files should be changed. I usually have
C an L in the name for LHC files and a T in the name for the Tevatron files.
C There are several files listed for plotting.
C The LO file is usually HIGGS.LOLM9...  since MODE=9 gives lo200.dat
C col 1 is Mass col2 is cross section
C The NLO file is usually HIGGS.NLO1LM5...  since MODE=5 gives alf119.dat
C The NLO file is usually HIGGS.NLO2LM5...  since MODE=5 gives alf119.dat
C col 1 is mass col3 is cross section
C The NLO file is usually HIGGS.NLO3LM5...  since MODE=5 gives alf119.dat
C The NNLO file is usually HIGGS.NNLO1LM1...  since MODE=1 gives vnvalf1155.dat
C The NNLO file is usually HIGGS.NNLO2LM1...  since MODE=1 gives vnvalf1155.dat
C The NNLO file is usually HIGGS.NNLO3LM1...  since MODE=1 gives vnvalf1155.dat
C col 1 is mass col3 is cross section
C The NNLO file is usually HIGGS.NNLO4LM1...  since MODE=1 gives vnvalf1155.dat
C First check that the program reproduces the results in Tables 1 and 2 
C in V. Ravindran, J. Smith and W.L van Neerven, Nucl.Phys. B 665 (2003) 325.
C Comments please forward to J. Smith at
C smith@insti.physics.sunysb.edu
**************************************************************************
C HERE FOLLOWS THE TOTAL CROSS SECTION sigma_{tot}
C IN PICOBARNS

      real*8 function higgsnnlorate(Q,ss)

      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,MU,MU2,MUR,MUR2
      REAL*8 N,N2,NF
      DIMENSION XL(10),XU(10)
      DIMENSION CROSS0(3),CROSS1(3),CROSSGG(3),CROSSQG(3),CROSSQQB(3)
C      DIMENSION UA(27)
      COMMON/BVEG1/XL,XU,ACC,NDIM,NCALL,ITMX,NPRN
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      COMMON/HIGGSSET/MODE,MODH,MODP

      EXTERNAL GG0,GG1R,GG1S,QG1,QQB1
      EXTERNAL GG2R,GG2S,QG2,QQB2,QQ2

c      OPEN(UNIT=11,FILE='higgs.dat',STATUS='old')
c      READ (11,*) MODH 
c      READ (11,*) MODP 
c      READ (11,*) SS 

      print *,modh,modp,ss

      PRINT '(''0 PROGRAM HIGGS'')'
      PRINT '(''0           MODH = '',i3)',MODH
      PRINT '(''0           MODP = '',i3)',MODP
      PRINT '(''0           SS = '',d20.7)',SS

c      OPEN(UNIT=14,FILE='HIGGS.LOLM9',STATUS='NEW')
C      OPEN(UNIT=14,FILE='HIGGS.LOTM9',STATUS='NEW')
c      REWIND 14
c      OPEN(UNIT=15,FILE='HIGGS.NLO1LM5',STATUS='NEW')
C      OPEN(UNIT=15,FILE='HIGGS.NLO1TM5',STATUS='NEW')
c      REWIND 15
c      OPEN(UNIT=16,FILE='HIGGS.NLO2LM5',STATUS='NEW')
C      OPEN(UNIT=16,FILE='HIGGS.NLO2TM5',STATUS='NEW')
c      REWIND 16
c      OPEN(UNIT=17,FILE='HIGGS.NLO3LM5',STATUS='NEW')
C      OPEN(UNIT=17,FILE='HIGGS.NLO3TM5',STATUS='NEW')
c      REWIND 17
c      OPEN(UNIT=18,FILE='HIGGS.NNLO1LM1',STATUS='NEW')
C      OPEN(UNIT=18,FILE='HIGGS.NNLO1TM1',STATUS='NEW')
c      REWIND 18
c      OPEN(UNIT=19,FILE='HIGGS.NNLO2LM1',STATUS='NEW')
C      OPEN(UNIT=19,FILE='HIGGS.NNLO2TM1',STATUS='NEW')
c      REWIND 19
c      OPEN(UNIT=20,FILE='HIGGS.NNLO3LM1',STATUS='NEW')
C      OPEN(UNIT=20,FILE='HIGGS.NNLO3TM1',STATUS='NEW')
c      REWIND 20
c      OPEN(UNIT=21,FILE='HIGGS.NNLO4LM1',STATUS='NEW')
C      OPEN(UNIT=21,FILE='HIGGS.NNLO4TM1',STATUS='NEW')
c      REWIND 21


C SCALAR HIGGS PRODUCTION CHOOSE: MODH=1
C PSEUDO SCALAR HIGGS PRODUCTION CHOOSE: MODH=2
C NOW CHOSEN IN DATA FILE
C      MODH=1
C      MODH=2

C HERE FOLLOWS THE VALUE FOR cotg \beta IN THE H2DM MODEL (cotg \beta >0.02)
      COTB=1.0D0

      IF(MODH.EQ.1) THEN
      WRITE(*,1)
    1 FORMAT(' ',' SCALAR HIGGS PRODUCTION')
      ELSEIF(MODH.EQ.2) THEN
      WRITE(*,2) COTB
    2 FORMAT('PSEUDO SCALAR HIGGS PRODUCTION',5X,'cotg(beta) =',D12.5)
      ENDIF

C PROTON-PROTON COLLISIONS CHOOSE: MODP=1
C PROTON-ANTI-PROTON COLLISIONS CHOOSE: MODP=2
C NOW CHOSEN IN DATA FILE

C      MODP=1
C      MODP=2

C CHOOSE THE CENTRE OF MASS ENERGY
C NOW CHOSEN IN DATA FILE

C      SS=14000.0D0
C      SS=2000.0D0

      IF(MODP.EQ.1) THEN
      WRITE(*,3)
    3 FORMAT(' ','PROTON-PROTON COLLISIONS')
      ELSEIF(MODP.EQ.2) THEN
      WRITE(*,4)
    4 FORMAT('PROTON-ANTI-PROTON COLLISIONS')
      ENDIF


      PI=3.14159265359D0
      GF=4541.68D0

C THE COLOUR FACTORS

      N=3.0D0
      N2=N*N
      CA=N
      CF=(N2-1.0D0)/N/2.0D0
      TF=0.5D0

      DO 5 I=1,10
      XL(I)=0.0D0
      XU(I)=1.0D0
    5 CONTINUE
      ACC=-1
      NPRN=0

C CHOOSE THE NUMBER OF LIGHT FLAVOURS

      NF=5.0D0


C----------------------------------------------------------
C CALCULATION OF THE CROSS SECTIONS IN LO IN THE MSBAR SCHEME
C----------------------------------------------------------
C MRST9    LAMBDA5=0.167 GEV (LO)  LAMBDA4=0.220 GEV        : MODE=9
C---------------------------------------------------------------------


C----------------------------------------------------------
C CALCULATION OF THE CROSS SECTIONS IN NLO IN THE MSBAR SCHEME
C----------------------------------------------------------
C MRST5    LAMBDA5=0.239 GEV (NLO)   LAMBDA4=0.323 GEV      : MODE=5
C MRST6    LAMBDA5=0.214 GEV (NLO)   LAMBDA4=0.290 GEV      : MODE=6
C MRST7    LAMBDA5=0.267 GEV (NLO)   LAMBDA4=0.362 GEV      : MODE=7
C MRST8    LAMBDA5=0.267 GEV (NLO)   LAMBDA4=0.353 GEV      : MODE=8
C----------------------------------------------------------

C----------------------------------------------------------
C CALCULATION OF THE CROSS SECTIONS IN NNLO IN THE MSBAR SCHEME
C----------------------------------------------------------
C MRST1  LAMBDA5=0.176 GEV (NNLO)  LAMBDA4=0.235 GEV     : MODE=1
C MRST2  LAMBDA5=0.176 GEV (NNLO)  LAMBDA4=0.235 GEV     : MODE=2
C MRST3  LAMBDA5=0.176 GEV (NNLO)  LAMBDA4=0.235 GEV     : MODE=3
C MRST4  LAMBDA5=0.209 GEV (NNLO)  LAMBDA4=0.267 GEV     : MODE=4
C----------------------------------------------------------


C HERE FOLLOWS THE MASS OF THE HIGGS BOSON IN GEV

c      DO 101 I=1,1
c      Q=90.0D0+DFLOAT(I)*10.0D0
C      Q=115.0D0
C      Q=275.0D0
C      Q=100.0D0
C      Q=200.0D0
C      Q=300.0D0
      Q2=Q*Q
      WRITE(*,6) Q
    6 FORMAT(' ','THE MASS OF THE HIGGS BOSON =',D12.5)
      HMT=173.4D0
      HMT2=HMT*HMT
      TAU=4.0D0*HMT2/Q2
      TAU2=TAU*TAU
      IF(TAU.GE.1.0D0) THEN
      FTAU=DASIN(0.5D0*Q/HMT)
      FTAU2=FTAU*FTAU
      ELSEIF(TAU.LT.1.0D0) THEN
      SQQ=DSQRT(1.0D0-TAU)
      DDL=(1.0D0-SQQ)/(1.0D0+SQQ)
      FTT=DLOG(DDL)
      FTAU2=-(FTT*FTT-PI*PI)/4.0D0
      ENDIF
      IF(MODH.EQ.1) THEN
      FFTAU=1.0D0+(1.0D0-TAU)*FTAU2
      ELSEIF(MODH.EQ.2) THEN
      FFTAU=FTAU2*COTB
      ENDIF
      FFTAU2=FFTAU*FFTAU

C HERE FOLLOWS THE CENTER OF MASS ENERGY

      S=SS*SS

      WRITE(*,7) SS
    7 FORMAT(' ','THE CENTER OF MASS ENERGY =',D12.5)
      XX=Q2/S
C      UA(1)=Q/10.0D0
c      UA(2)=Q/9.9D0
c      UA(3)=Q/9.8D0
c      UA(4)=Q/9.5D0
c      UA(5)=Q/9.0D0
c      UA(6)=Q/8.0D0
c      UA(7)=Q/7.0D0
c      UA(8)=Q/6.0D0
c      UA(9)=Q/5.0D0
c      UA(10)=Q/4.0D0
c      UA(11)=Q/3.0D0
c      UA(12)=Q/2.0D0
c      UA(13)=Q*3.0D0/4.0D0
c      UA(14)=Q
c      UA(15)=Q*4.0D0/3.0D0
c      UA(16)=Q*2.0D0
c      UA(17)=Q*3.0D0
c      UA(18)=Q*4.0D0
c      UA(19)=Q*5.0D0
c      UA(20)=Q*6.0D0
c      UA(21)=Q*7.0D0
c      UA(22)=Q*8.0D0
c      UA(23)=Q*9.0D0
c      UA(24)=Q*9.5D0
c      UA(25)=Q*9.8D0
c      UA(26)=Q*9.9D0
c      UA(27)=Q*10.0D0
c      DO 101 I=1,27
c      MU=UA(I)
      MU=Q
C      MU=Q/2.0D0
C      MU=2.0D0*Q
      MU2=MU*MU
      WRITE(*,8) MU
    8 FORMAT(' ','THE FACTORIZATION SCALE=',D12.5)
C HERE FOLLOWS THE RENORMALIZATION SCALE IN GEV
      MUR=MU
      MUR2=MU2
      WRITE(*,9) MUR
    9 FORMAT(' ','THE RENORMALIZATION SCALE=',D12.5)
C HERE FOLLOWS THE NUMBER OF LIGHT FLAVOURS
      NFL=IDINT(NF)
      WRITE(*,10) NFL
   10 FORMAT(' ','THE NUMBER OF FLAVOURS=',I3)
C HERE FOLLOWS THE SCALE PARAMETER LAMBDA IN GEV

C------------------------------------------------------------------
C NL=1 CALCULATION OF THE CROSS SECTION IN  LEADING ORDER
C------------------------------------------------------------------

C------------------------------------------------------------------
C NL=2 CALCULATION OF THE CROSS SECTION IN NEXT-TO-LEADING ORDER
C------------------------------------------------------------------

C------------------------------------------------------------------
C NL=3 CALCULATION OF THE CROSS SECTION IN NEXT-TO-NEXT-TO-LEADING ORDER
C------------------------------------------------------------------
C
C   REMEMBER TO COMPILE THE CORRECT PARTON.F

      DO 100 NL=1,3

      IF(NL.EQ.1) THEN
      WRITE(*,11)
   11 FORMAT(' ','CALCULATION UP TO LEADING ORDER')
      ELSEIF(NL.EQ.2) THEN
      WRITE(*,12)
   12  FORMAT(' ','CALCULATION UP TO NEXT-TO-LEADING ORDER')
      ELSEIF(NL.EQ.3) THEN
      WRITE(*,13)
   13 FORMAT(' ','CALCULATION UP TO NEXT-TO-NEXT-TO-LEADING ORDER')
      ENDIF
CJS TAKE CORRECT PARTON.F FILE
      IF(NL.EQ.1) THEN
      MODE=9
      LAMBDA=0.167D0
      
      ELSEIF(NL.EQ.2) THEN
      MODE=5
      LAMBDA=0.239D0
       
      ELSEIF(NL.EQ.3) THEN
      MODE=1
      LAMBDA=0.176D0
      ENDIF

      WRITE(*,14) NL,MODE
   14 FORMAT(' ','NL=',I3,5X,'MODE =',I3)

      WRITE(*,15) LAMBDA
   15 FORMAT(' ','THE QCD SCALE PARAMETER LAMBDA=',D12.5)

C HERE FOLLOWS THE RUNNING COUPLING CONSTANT

      FL=NF

      IF(NL.EQ.1) THEN

C FOR NL=1 CHOOSE ALSW=ALFAS1 (LO PARAMETRIZATION)

      ALSW=ALFAS1(MUR,LAMBDA,FL)
      ALSWZ=ALFAS1(91.2D0,LAMBDA,FL)

      ELSEIF(NL.EQ.2) THEN

C FOR NL=2 CHOOSE ALSW=ALFAS2 (NLO PARAMETRIZATION)

      ALSW=ALFAS2(MUR,LAMBDA,FL)
      ALSWZ=ALFAS2(91.2D0,LAMBDA,FL)
      ELSEIF(NL.EQ.3) THEN

C FOR NL=3 CHOOSE ALSW=ALFAS3 (NNLO PARAMETRIZATION)

      ALSW=ALFAS3(MUR,LAMBDA,FL)
      ALSWZ=ALFAS3(91.2D0,LAMBDA,FL)

      ENDIF
      WRITE(*,16) ALSW
   16 FORMAT(' ','THE RUNNING COUPLING CONSTANT ALPHAS=',D12.5)
      WRITE(*,166) ALSWZ
  166 FORMAT(' ','ALPHAS(M_Z)=',D12.5)
      ALSPW=ALSW/4.0D0/PI
      ALSPW2=ALSPW*ALSPW
      G2=4.0D0*DSQRT(2.0D0)*GF*ALSPW2*TAU2*FFTAU2
      FACT=PI*G2/(N2-1.0D0)/8.0D0

C HERE FOLLOWS THE BORN CROSS SECTION

C g + g -> H

      NDIM=1
CJS      ITMX=10
CJS      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,17)
C   17 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF GG0')
      CALL VEGAS(GG0,RGG0,F,X)
C      ITMX=3
C      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(GG0,RGG0,F,X)
C---------------------------------------------------------------------
      SIGGG0=FACT*RGG0

      IF(NL.GT.1) GO TO 102
      WRITE(*,200) RGG0
  200 FORMAT(' ','RGG0 =',D12.5)
      WRITE(*,18) SIGGG0
   18 FORMAT(' ','sigma_{gg}^(0) =',D12.5)
      CROSS0(NL)=SIGGG0

c      WRITE(14,299) Q,SIGGG0
C      WRITE(14,299) MU/Q,SIGGG0
C      WRITE(14,299) MU,SIGGG0
  299 FORMAT(D12.4,2X,D12.4)

  102 IF(NL.EQ.1) GO TO 100

C HERE FOLLOW THE FIRST ORDER BREMSSTRAHLUNGS CROSS SECTIONS AND CROSS SECTIONS
C COMING FROM OTHER FIRST ORDER SUBPROCESSES

C g + g -> g + H

      NDIM=2
C      ITMX=10
C      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,19)
C   19 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF GG1R')
      CALL VEGAS(GG1R,RGG1R,F,X)
CJS      ITMX=3
CJS      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(GG1R,RGG1R,F,X)
C      ITMX=10
C      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,20)
C   20 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF GG1S')
      CALL VEGAS(GG1S,RGG1S,F,X)
CJS      ITMX=3
CJS      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(GG1S,RGG1S,F,X)
      IF(MODH.EQ.1) THEN
      C11=10.0D0*CA-6.0D0*CF
      ELSEIF(MODH.EQ.2) THEN
      C11=0.0D0
      ENDIF
      RGG1=ALSPW*FACT*(RGG1R+RGG1S+(CGG1SPV(XX)+C11)*RGG0)

C     SOFT PLUS VIRTUAL GLUON APPROXIMATION: SGG1=sigma^(S+V,1)

      SGG1=ALSPW*FACT*(RGG1S+(CGG1SPV(XX)+C11)*RGG0)
      RRGG1R=ALSPW*FACT*RGG1R
      RRGG1S=ALSPW*FACT*RGG1S
      RRGG1V=ALSPW*FACT*(CGG1SPV(XX)+C11)*RGG0
C--------------------------
      SIGGG1=SIGGG0+RGG1

C     SOFT PLUS VIRTUAL GLUON APPROXIMATION: SIGSPV1=sigma_(S+V,1)

      SIGSPV1=SIGGG0+SGG1

C q + g -> q + H,  qb + g -> qb + H

CJS      ITMX=10
CJS      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,23)
C   23 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF QG1')
      CALL VEGAS(QG1,RQG1,F,X)
CJS      ITMX=3
CJS      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(QG1,RQG1,F,X)
      SIGQG1=ALSPW*FACT*RQG1

C      WRITE(*,24) SIGQG1
C   24 FORMAT(' ','sigma_{qg}^(1) =',D12.5)
C      CROSSQG(NL)=SIGQG1

C q + qb -> g + H

CJS      ITMX=10
CJS      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,25)
C   25 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF QQB1')
      CALL VEGAS(QQB1,RQQB1,F,X)
CJS      ITMX=3
CJS      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(QQB1,RQQB1,F,X)
      SIGQQB1=ALSPW*FACT*RQQB1
C      WRITE(*,26) SIGQQB1
C   26 FORMAT(' ','sigma_{qqb}_(1) =',D12.5)

      SIGT1=SIGGG1+SIGQG1+SIGQQB1
C      CROSS1(NL)=SIGT1

C     SOFT PLUS VIRTUAL GLUON APPROXIMATION: SIGSPV1=sigma_(S+V,1)

C VALIDITY OF THE SOFT PLUS VIRTUAL GLUON APPROXIMATION

      R1=SIGSPV1/SIGT1

      IF(NL.GT.2) GO TO 103
      WRITE(*,201) RRGG1R,RRGG1S,RRGG1V
  201 FORMAT(' ','RGG1R =',D12.5,5X,'RGG1S =',D12.5,5X,'RGG1V =',D12.5)
      WRITE(*,21) RGG1,SGG1
   21 FORMAT(' ','sigma_{gg}^(1) =',D12.5,5X,'sigma^(S+V,1) =',D12.5)
      CROSSGG(NL)=SIGGG1

      WRITE(*,22) SIGGG1,SIGSPV1
   22 FORMAT(' ','sigma_{gg}_(1) =',D12.5,5X,'sigma_(S+V,1) =',D12.5)

      WRITE(*,24) SIGQG1
   24 FORMAT(' ','sigma_{qg}^(1) =',D12.5)
      CROSSQG(NL)=SIGQG1

      WRITE(*,26) SIGQQB1
   26 FORMAT(' ','sigma_{qqb}_(1) =',D12.5)
      CROSSQQB(NL)=SIGQQB1

      CROSS1(NL)=SIGT1

      WRITE(*,27) SIGT1,SIGSPV1
   27 FORMAT(' ','sigma^{tot}_1 =',D12.5,5X,'sigma_(S+V,1) =',D12.5)
      DKGG1=SIGGG1/CROSS0(1)
      WRITE(*,28) DKGG1
   28 FORMAT(' ','K_{gg}^{(1)} =',D12.5)
      DK1=SIGT1/CROSS0(1)
      WRITE(*,29) DK1
   29 FORMAT(' ','K_{1} =',D12.5)

C       VALIDITY OF THE SOFT PLUS VIRTUAL GLUON APPROXIMATION

      WRITE(*,30) R1
   30 FORMAT(' ','sigma_(S+V,1)/sigma^{tot}_1 =',D12.5)
C-------------------------------------------------------------------------
c      WRITE(15,398) Q,RGG1,SGG1,SIGGG1,SIGSPV1,SIGQG1
CJS      WRITE(15,398) MU/Q,RGG1,SGG1,SIGGG1,SIGSPV1,SIGQG1
CJS      WRITE(15,398) MU,RGG1,SGG1,SIGGG1,SIGSPV1,SIGQG1
  398 FORMAT(D12.4,2X,D12.4,2X,D12.4,2X,D12.4,2X,D12.4,2X,D12.4)

c      WRITE(16,399) Q,SIGQQB1,SIGT1,SIGSPV1
CJS      WRITE(16,399) MU/Q,SIGQQB1,SIGT1,SIGSPV1
CJS      WRITE(16,399) MU,SIGQQB1,SIGT1,SIGSPV1
  399 FORMAT(D12.4,2X,D12.4,2X,D12.4,2X,D12.4)

c      WRITE(17,400) Q,DKGG1,DK1,R1
CJS      WRITE(17,400) MU/Q,DKGG1,DK1,R1
CJS      WRITE(17,400) MU,DKGG1,DK1,R1
  400 FORMAT(D12.4,2X,D12.4,2X,D12.4,2X,D12.4)

  103 IF(NL.EQ.2) GO TO 100


C HERE FOLLOW THE SECOND ORDER BREMSSTRAHLUNGS CROSS SECTIONS AND CROSS SECTIONS
C COMING FROM OTHER SECOND ORDER SUBPROCESSES

C g + g -> g + g + H, g + g -> q + qb + H

CJS      ITMX=10
CJS      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,31)
C   31 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF GG2R')
      CALL VEGAS(GG2R,RGG2R,F,X)
CJS      ITMX=3
CJS      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(GG2R,RGG2R,F,X)
CJS      ITMX=10
CJS      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,32)
C   32 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF GG2S')
      CALL VEGAS(GG2S,RGG2S,F,X)
CJS      ITMX=3
CJS      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(GG2S,RGG2S,F,X)
      IF(MODH.EQ.1) THEN
      C22=(16.0D0*NF*TF*CF+14.0D0*CA**2-22.0D0*CA*CF)
     &*DLOG(MUR2/HMT2)-10.0D0*NF*TF*CF-94.0D0*NF*TF*CA/9.0D0
     &-290.0D0*CA*CF/3.0D0-8.0D0*TF*CF/3.0D0+36.0D0*CF**2
     &-5.0D0*TF*CA/3.0D0+1513.D0*CA**2/18.0D0
      ELSEIF(MODH.EQ.2) THEN
      C22=CA*TF*NF*(-16.D0/3.D0 + 32.D0/3.D0*DLOG(MUR2/HMT2))
      ENDIF
      CREN=(11.0D0*CA-2.0D0*FL)*DLOG(MUR2/MU2)/3.0D0
      RGG2=ALSPW2*FACT*(RGG2R+RGG2S+(CGG2SPV(XX)+C22)*RGG0
     &+(C11+CREN)*(RGG1R+RGG1S+CGG1SPV(XX)*RGG0))

C     SOFT PLUS VIRTUAL GLUON APPROXIMATION: SGG2=sigma^(S+V,2)

      SGG2=ALSPW2*FACT*(RGG2S+(CGG2SPV(XX)+C22)*RGG0
     &+(C11+CREN)*(RGG1S+CGG1SPV(XX)*RGG0))

      RRGG2R=ALSPW2*FACT*(RGG2R+(C11+CREN)*RGG1R)
      RRGG2S=ALSPW2*FACT*(RGG2S+(C11+CREN)*RGG1S)
      RRGG2V=ALSPW2*FACT*((CGG2SPV(XX)+C22)*RGG0+(C11+CREN)
     &*CGG1SPV(XX)*RGG0)
      WRITE(*,202) RRGG2R,RRGG2S,RRGG2V
  202 FORMAT(' ','RGG2R =',D12.5,5X,'RGG2S =',D12.5,5X,'RGG2V =',D12.5)

      WRITE(*,33) RGG2,SGG2
   33 FORMAT(' ','sigma_{gg}^(2) =',D12.5,5X,'sigma^(S+V,2) =',D12.5)
      SIGGG2=SIGGG1+RGG2

C     SOFT PLUS VIRTUAL GLUON APPROXIMATION: SIGSPV2=sigma_(S+V,2)

      SIGSPV2=SIGSPV1+SGG2
      WRITE(*,34) SIGGG2,SIGSPV2
   34 FORMAT(' ','sigma_{gg}_(2) =',D12.5,5X,'sigma_(S+V,2) =',D12.5)

C q + g -> q + g + H, qb + g -> qb + g + H

CJS      ITMX=10
CJS      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,35)
C   35 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF QG2')
      CALL VEGAS(QG2,RQG2R,F,X)
CJS      ITMX=3
CJS      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(QG2,RQG2R,F,X)
      RQG2=ALSPW2*FACT*(RQG2R+(C11+CREN)*RQG1)
      WRITE(*,36) RQG2
   36 FORMAT(' ','sigma^{qg}^(2) =',D12.5)
      SIGQG2=SIGQG1+RQG2
      WRITE(*,37) SIGQG2
   37 FORMAT(' ','sigma_{qg}_(2) =',D12.5)

C q + qb -> g + g + H,
C q1 + qb1 -> \sum_{i=1}^{n_f} qi + qib + H (annihilation process only),
C q + qb -> q + qb + H (minus annihilation graph)
C q1 + q2b -> q1 + q2b + H

CJS      ITMX=10
CJS      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,38)
C   38 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF QQB2')
      CALL VEGAS(QQB2,RQQB2R,F,X)
CJS      ITMX=3
CJS      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(QQB2,RQQB2R,F,X)
      RQQB2=ALSPW2*FACT*(RQQB2R+(C11+CREN)*RQQB1)
      WRITE(*,39) RQQB2
   39 FORMAT(' ','sigma_{qqb}^(2) =',D12.5)
      SIGQQB2=SIGQQB1+RQQB2
      WRITE(*,40) SIGQQB2
   40 FORMAT(' ','sigma_{qqb}_(2) =',D12.5)


C q1 + q2 -> q1 + q2 + H, q1b + q2b -> q1b + q2b + H
C q + q -> q + q + H, qb + qb -> qb + qb + H

CJS      ITMX=10
CJS      NCALL=1000
      ITMX=5
      NCALL=10000
C      WRITE(*,41)
C   41 FORMAT(' ','HERE FOLLOWS THE INTEGRATION OF QQ2')
      CALL VEGAS(QQ2,RQQ2,F,X)
CJS      ITMX=3
CJS      NCALL=10000
      ITMX=2
      NCALL=50000
      CALL VEGAS1(QQ2,RQQ2,F,X)
      SIGQQ2=ALSPW2*FACT*RQQ2
      WRITE(*,42) SIGQQ2
   42 FORMAT(' ','sigma_{qq}^(2) =',D12.5)
      SIGT2=SIGGG2+SIGQQB2+SIGQG2+SIGQQ2

C     SOFT PLUS VIRTUAL GLUON APPROXIMATION: SIGSPV2=sigma_(S+V,2)

      WRITE(*,43) SIGT2,SIGSPV2
   43 FORMAT(' ','sigma^{tot}_2 =',D12.5,5X,'sigma_(S+V,2) =',D12.5)
      DKGG2=SIGGG2/CROSSGG(2)
      DKQG1=SIGQG2/CROSSQG(2)
      DKQQB1=SIGQQB2/CROSSQQB(2)
      WRITE(*,44) DKGG2,DKQG1
   44 FORMAT(' ','K_{gg}^{(2)} =',D12.5,2X,'K_{qg}^{(2)} =',D12.5)
      WRITE(*,45) DKQQB1
   45 FORMAT(' ','K_{qqb}^{(2)} =',D12.5)
      DK2=SIGT2/CROSS1(2)
      WRITE(*,46) DK2
   46 FORMAT(' ','K_{2} =',D12.5)

C VALIDITY OF THE SOFT PLUS VIRTUAL GLUON APPROXIMATION

      R2=SIGSPV2/SIGT2
      WRITE(*,47) R2
   47 FORMAT(' ','sigma_(S+V,2)/sigma^{tot}_2 =',D12.5)

c      WRITE(18,497) Q,RGG2,SGG2,SIGGG2,SIGSPV2
CJS      WRITE(18,497) MU/Q,RGG2,SGG2,SIGGG2,SIGSPV2
CJS      WRITE(18,497) MU,RGG2,SGG2,SIGGG2,SIGSPV2
  497 FORMAT(D12.4,2X,D12.4,2X,D12.4,2X,D12.4,2X,D12.4)

c      WRITE(19,498) Q,RQG2,SIGQG2,RQQB2,SIGQQB2
CJS      WRITE(19,498) MU/Q,RQG2,SIGQG2,RQQB2,SIGQQB2
CJS      WRITE(19,498) MU,RQG2,SIGQG2,RQQB2,SIGQQB2
  498 FORMAT(D12.4,2X,D12.4,2X,D12.4,2X,D12.4,2X,D12.4)

c      WRITE(20,499) Q,SIGQQ2,SIGT2,SIGSPV2
CJS      WRITE(20,499) MU/Q,SIGQQ2,SIGT2,SIGSPV2
CJS      WRITE(20,499) MU,SIGQQ2,SIGT2,SIGSPV2
  499 FORMAT(D12.4,2X,D12.4,2X,D12.4,2X,D12.4)

c      WRITE(21,500) Q,DKGG2,DKQG1,DKQQB1,DK2,R2
CJS      WRITE(21,500) MU/Q,DKGG2,DKQG1,DKQQB1,DK2,R2
CJS      WRITE(21,500) MU,DKGG2,DKQG1,DKQQB1,DK2,R2
  500 FORMAT(D12.4,2X,D12.4,2X,D12.4,2X,D12.4,2X,D12.4,2X,D12.4)


  100 CONTINUE
c  101 CONTINUE

      higgsnnlorate=SIGT2

      return
      END

      REAL*8 FUNCTION GG0(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y1=(1.0D0-XX)*X(1)+XX
      Y2=XX/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      HGG=GL1*GL2
      GG0=(1.0D0-XX)*HGG/Y1
      RETURN
      END

      REAL*8 FUNCTION GG1R(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y1=(1.0D0-XX)*X(1)+XX
      Y2=(1.0D0-XX/Y1)*X(2)+XX/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      YY=XX/Y1/Y2
      HGG=GL1*GL2
      GG1R=(1.0D0-XX)*(1.0D0-XX/Y1)*HGG*CGG1R(YY)/Y1/Y2
      RETURN
      END

      REAL*8 FUNCTION GG1S(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y=(1.0D0-XX)*X(1)+XX
      Y1=(1.0D0-XX/Y)*X(2)+XX/Y
      Y2=XX/Y/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      Y3=(1.0D0-XX)*X(2)+XX
      Y4=XX/Y3
      CALL STRUCT(Y3,MU,MODE,UV3,DV3,US3,DS3,ST3,CH3,BOT3,GL3)
      CALL STRUCT(Y4,MU,MODE,UV4,DV4,US4,DS4,ST4,CH4,BOT4,GL4)
      HGG1=GL1*GL2
      HGG2=GL3*GL4
      A1=(1.0D0-XX)*(1.0D0-XX/Y)*HGG1/Y/Y1
      A2=(1.0D0-XX)*(1.0D0-XX)*HGG2/Y3
      GG1S=(A1-A2)*CGG1SOFT(Y)
      RETURN
      END


      REAL*8 FUNCTION QG1(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y1=(1.0D0-XX)*X(1)+XX
      Y2=(1.0D0-XX/Y1)*X(2)+XX/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      YY=XX/Y1/Y2
      IF(MODP.EQ.1) THEN
C 1 = PROTON, 2 = PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=UV2+US2
      U2B=US2
      D2=DV2+DS2
      D2B=DS2
      ELSEIF(MODP.EQ.2) THEN
C 1 = PROTON, 2 = ANTI-PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=US2
      U2B=UV2+US2
      D2=DS2
      D2B=DV2+DS2
      ENDIF
      HQG=GL1*(U2+U2B+D2+D2B+2.0D0*(ST2+CH2+BOT2))
     &+GL2*(U1+U1B+D1+D1B+2.0D0*(ST1+CH1+BOT1))
      QG1=(1.0D0-XX)*(1.0D0-XX/Y1)*HQG*CQG1(YY)/Y1/Y2
      RETURN
      END


      REAL*8 FUNCTION QQB1(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y1=(1.0D0-XX)*X(1)+XX
      Y2=(1.0D0-XX/Y1)*X(2)+XX/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      YY=XX/Y1/Y2
      IF(MODP.EQ.1) THEN
C 1 = PROTON, 2 = PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=UV2+US2
      U2B=US2
      D2=DV2+DS2
      D2B=DS2
      ELSEIF(MODP.EQ.2) THEN
C 1 = PROTON, 2 = ANTI-PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=US2
      U2B=UV2+US2
      D2=DS2
      D2B=DV2+DS2
      ENDIF
      HQQB=U1*U2B+U1B*U2+D1*D2B+D1B*D2+2.0D0*(ST1*ST2+CH1*CH2
     &+BOT1*BOT2)
      QQB1=(1.0D0-XX)*(1.0D0-XX/Y1)*HQQB*CQQB1(YY)/Y1/Y2
      RETURN
      END

      REAL*8 FUNCTION GG2R(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y1=(1.0D0-XX)*X(1)+XX
      Y2=(1.0D0-XX/Y1)*X(2)+XX/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      YY=XX/Y1/Y2
      HGG=GL1*GL2
      GG2R=(1.0D0-XX)*(1.0D0-XX/Y1)*HGG*CGG2R(YY)/Y1/Y2
      RETURN
      END

      REAL*8 FUNCTION GG2S(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y=(1.0D0-XX)*X(1)+XX
      Y1=(1.0D0-XX/Y)*X(2)+XX/Y
      Y2=XX/Y/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      Y3=(1.0D0-XX)*X(2)+XX
      Y4=XX/Y3
      CALL STRUCT(Y3,MU,MODE,UV3,DV3,US3,DS3,ST3,CH3,BOT3,GL3)
      CALL STRUCT(Y4,MU,MODE,UV4,DV4,US4,DS4,ST4,CH4,BOT4,GL4)
      HGG1=GL1*GL2
      HGG2=GL3*GL4
      A1=(1.0D0-XX)*(1.0D0-XX/Y)*HGG1/Y/Y1
      A2=(1.0D0-XX)*(1.0D0-XX)*HGG2/Y3
      GG2S=(A1-A2)*CGG2SOFT(Y)
      RETURN
      END


      REAL*8 FUNCTION QG2(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y1=(1.0D0-XX)*X(1)+XX
      Y2=(1.0D0-XX/Y1)*X(2)+XX/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      YY=XX/Y1/Y2
      IF(MODP.EQ.1) THEN
C 1 = PROTON, 2 = PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=UV2+US2
      U2B=US2
      D2=DV2+DS2
      D2B=DS2
      ELSEIF(MODP.EQ.2) THEN
C 1 = PROTON, 2 = ANTI-PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=US2
      U2B=UV2+US2
      D2=DS2
      D2B=DV2+DS2
      ENDIF
      HQG=GL1*(U2+U2B+D2+D2B+2.0D0*(ST2+CH2+BOT2))
     &+GL2*(U1+U1B+D1+D1B+2.0D0*(ST1+CH1+BOT1))
      QG2=(1.0D0-XX)*(1.0D0-XX/Y1)*HQG*CQG2(YY)/Y1/Y2
      RETURN
      END

      REAL*8 FUNCTION QQB2(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y1=(1.0D0-XX)*X(1)+XX
      Y2=(1.0D0-XX/Y1)*X(2)+XX/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      YY=XX/Y1/Y2
      IF(MODP.EQ.1) THEN
C 1 = PROTON, 2 = PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=UV2+US2
      U2B=US2
      D2=DV2+DS2
      D2B=DS2
      ELSEIF(MODP.EQ.2) THEN
C 1 = PROTON, 2 = ANTI-PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=US2
      U2B=UV2+US2
      D2=DS2
      D2B=DV2+DS2
      ENDIF
      HQQB=U1*U2B+U1B*U2+D1*D2B+D1B*D2+2.0D0*(ST1*ST2+CH1*CH2
     &+BOT1*BOT2)
      HQ1Q2=U1*(D2B+ST2+CH2+BOT2)+D1*(U2B+ST2+CH2+BOT2)+ST1*(U2B+D2B
     &+CH2+BOT2)+CH1*(U2B+D2B+ST2+BOT2)+BOT1*(U2B+D2B+ST2+CH2)
     &+U1B*(D2+ST2+CH2+BOT2)+D1B*(U2+ST2+CH2+BOT2)+ST1*(U2+D2
     &+CH2+BOT2)+CH1*(U2+D2+ST2+BOT2)+BOT1*(U2+D2+ST2+CH2)
      AA=HQ1Q2*CQ1Q22(YY)+HQQB*CQQB2(YY)
      QQB2=(1.0D0-XX)*(1.0D0-XX/Y1)*AA/Y1/Y2
      RETURN
      END

      REAL*8 FUNCTION QQ2(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 MU,MU2
      DIMENSION X(10)
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/HIGGSSET/MODE,MODH,MODP
      Y1=(1.0D0-XX)*X(1)+XX
      Y2=(1.0D0-XX/Y1)*X(2)+XX/Y1
      CALL STRUCT(Y1,MU,MODE,UV1,DV1,US1,DS1,ST1,CH1,BOT1,GL1)
      CALL STRUCT(Y2,MU,MODE,UV2,DV2,US2,DS2,ST2,CH2,BOT2,GL2)
      YY=XX/Y1/Y2
      IF(MODP.EQ.1) THEN
C 1 = PROTON, 2 = PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=UV2+US2
      U2B=US2
      D2=DV2+DS2
      D2B=DS2
      ELSEIF(MODP.EQ.2) THEN
C 1 = PROTON, 2 = ANTI-PROTON
      U1=UV1+US1
      U1B=US1
      D1=DV1+DS1
      D1B=DS1
      U2=US2
      U2B=UV2+US2
      D2=DS2
      D2B=DV2+DS2
      ENDIF
      HQ1Q2=U1*(D2+ST2+CH2+BOT2)+D1*(U2+ST2+CH2+BOT2)
     &+ST1*(U2+D2+CH2+BOT2)+CH1*(U2+D2+ST2+BOT2)
     &+BOT1*(U2+D2+ST2+CH2)
      HQQ=U1*U2+D1*D2+ST1*ST2+CH1*CH2+BOT1*BOT2
      HQ1BQ2B=U1B*(D2B+ST2+CH2+BOT2)+D1B*(U2B+ST2+CH2+BOT2)
     &+ST1*(U2B+D2B+CH2+BOT2)+CH1*(U2B+D2B+ST2+BOT2)
     &+BOT1*(U2B+D2B+ST2+CH2)
      HQBQB=U1B*U2B+D1B*D2B+ST1*ST2+CH1*CH2+BOT1*BOT2
      AA=(HQ1Q2+HQ1BQ2B)*CQ1Q22(YY)+(HQQ+HQBQB)*CQQ2(YY)
      QQ2=(1.0D0-XX)*(1.0D0-XX/Y1)*AA/Y1/Y2
      RETURN
      END

      DOUBLE PRECISION FUNCTION CGG1R(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      DL1=DLOG(Q2/MU2)
      DLM=DLOG(1.0D0-X)
      DL=DLOG(X)
      DM=1.0D0/(1.0D0-X)
      REGGG1CA =
     &  + DL1 * (  - 16.D0*X + 8.D0*X**2 - 8.D0*X**3 )
      REGGG1CA = REGGG1CA + DL * (  - 8.D0*DM + 16.D0*X - 8.D0*X**2 + 8.
     &    D0*X**3 )
      REGGG1CA = REGGG1CA + DLM * (  - 32.D0*X + 16.D0*X**2 - 16.D0*
     &    X**3 )
      REGGG1CA = REGGG1CA - 22.D0/3.D0 + 22.D0*X - 22.D0*X**2 + 22.D0/3.
     &    D0*X**3
      CGG1R=CA*REGGG1CA
      RETURN
      END

      DOUBLE PRECISION FUNCTION CGG1SPV(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      COMMON/HIGGSSET/MODE,MODH,MODP
      ZETA2=1.6449340668D0
      DL1=DLOG(Q2/MU2)
      DLM=DLOG(1.0D0-X)
      SPVGG1CA =
     &  + ZETA2 * ( 8.D0 )
      DLGG1CA =
     &  + DL1*DLM * ( 8.D0 )
      DLGG1CA = DLGG1CA + DLM**2 * ( 8.D0 )
      CGG1SPV=CA*(SPVGG1CA+DLGG1CA)
      IF(MODH.EQ.1) THEN
      CGG1SPV=CGG1SPV
      ELSEIF(MODH.EQ.2) THEN
      CGG1SPV=CGG1SPV+CA*8.D0
      ENDIF
      RETURN
      END

      DOUBLE PRECISION FUNCTION CGG1SOFT(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      DL1=DLOG(Q2/MU2)
      DLM=DLOG(1.0D0-X)
      DM=1.0D0/(1.0D0-X)
      SOFTGG1CA =
     &  + DL1 * ( 8.D0*DM )
      SOFTGG1CA = SOFTGG1CA + DLM * ( 16.D0*DM )
      CGG1SOFT=CA*SOFTGG1CA
      RETURN
      END

      DOUBLE PRECISION FUNCTION CQG1(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      DL1=DLOG(Q2/MU2)
      DLM=DLOG(1.0D0-X)
      DL=DLOG(X)
      SQG1CF =
     &  + DL1 * ( 4.D0 - 4.D0*X + 2.D0*X**2 )
      SQG1CF = SQG1CF + DL * (  - 4.D0 + 4.D0*X - 2.D0*X**2 )
      SQG1CF = SQG1CF + DLM * ( 8.D0 - 8.D0*X + 4.D0*X**2 )
      SQG1CF = SQG1CF - 3.D0 + 6.D0*X - X**2
      CQG1=CF*SQG1CF
      RETURN
      END


      DOUBLE PRECISION FUNCTION CQQB1(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 NF
      COMMON/COLOR/CA,CF,TF,NF
      SQQB1CF2 =
     &  + 8.D0/3.D0 - 8.D0*X + 8.D0*X**2 - 8.D0/3.D0*X**3
      CQQB1=CF**2*SQQB1CF2
      RETURN
      END

      DOUBLE PRECISION FUNCTION CGG2R(X)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 WGPLG
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      COMMON/HIGGSSET/MODE,MODH,MODP
      ZETA2=1.6449340668D0
      ZETA3=1.2020569031D0
      DL1=DLOG(Q2/MU2)
      DL2=DL1*DL1
      DLM=DLOG(1.0D0-X)
      DL=DLOG(X)
      Z=(1.0D0-X)/(1.0D0+X)
      S21Z=WGPLG(2,1,Z)
      S21MZ=WGPLG(2,1,-Z)
      S121MX=WGPLG(1,2,1.0D0-X)
      S12MX=WGPLG(1,2,-X)
      S211MX=WGPLG(2,1,1.0D0-X)
      S21MX=WGPLG(2,1,-X)
      S111MX=WGPLG(1,1,1.0D0-X)
      S11MX=WGPLG(1,1,-X)
      DLM=DLOG(1.0D0-X)
      DLP=DLOG(1.0D0+X)
      DL=DLOG(X)
      DM=1.0D0/(1.0D0-X)
      DP=1.0D0/(1.0D0+X)
      REGGG2CA2 =
     &  + DL2*DL * (  - 32.D0*DM - 96.D0*X**2 + 32.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL2*DLM * (  - 128.D0*X + 64.D0*X**2 - 64.
     &    D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL2 * (  - 352.D0/3.D0 + 376.D0/3.D0*X -
     &    332.D0/3.D0*X**2 + 132.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL1*DL*DLM * (  - 224.D0*DM + 192.D0*X -
     &    480.D0*X**2 + 224.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL1*DL*DLP * ( 32.D0*DP + 64.D0*X + 32.D0
     &    *X**2 + 32.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL1*DL * ( 176.D0 + 88.D0/3.D0*DM - 904.D0
     &    /3.D0*X + 1328.D0/3.D0*X**2 - 1496.D0/3.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL1*DL**2 * ( 40.D0*DM - 8.D0*DP + 128.D0
     &    *X**2 - 48.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL1*DLM * (  - 528.D0 + 2032.D0/3.D0*X -
     &    1856.D0/3.D0*X**2 + 1760.D0/3.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL1*DLM**2 * (  - 384.D0*X + 192.D0*X**2
     &     - 192.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL1*S111MX * (  - 256.D0*X - 256.D0*X**2
     &     )
      REGGG2CA2 = REGGG2CA2 + DL1*S11MX * ( 32.D0*DP + 64.D0*X + 32.D0*
     &    X**2 + 32.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL1*ZETA2 * ( 16.D0*DP + 192.D0*X - 64.D0
     &    *X**2 + 96.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL1 * ( 1262.D0/3.D0 - 3562.D0/9.D0*X +
     &    3026.D0/9.D0*X**2 - 4322.D0/9.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL*DLM*DLP * ( 64.D0*DP + 128.D0*X + 64.D0
     &    *X**2 + 64.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL*DLM * ( 1232.D0/3.D0 + 176.D0/3.D0*DM
     &     - 2144.D0/3.D0*X + 2848.D0/3.D0*X**2 - 2992.D0/3.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL*DLM**2 * (  - 248.D0*DM + 240.D0*X -
     &    504.D0*X**2 + 248.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL*DLP * (  - 112.D0/3.D0 - 32.D0*X + 56.D
     &    0*X**2 + 88.D0/3.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL*DLP**2 * (  - 24.D0 + 16.D0*DP + 8.D0*
     &    X - 32.D0*X**2 - 32.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL*S111MX * ( 8.D0 - 56.D0*DM - 48.D0*DP
     &     + 8.D0*X - 88.D0*X**2 + 8.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL*S11MX * ( 24.D0 - 64.D0*DP - 104.D0*X
     &     - 16.D0*X**2 + 16.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL*ZETA2 * ( 8.D0 + 144.D0*DM - 24.D0*DP
     &     - 72.D0*X + 392.D0*X**2 - 168.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL * (  - 3602.D0/9.D0 - 536.D0/9.D0*DM
     &     + 2188.D0/3.D0*X - 1582.D0/3.D0*X**2 + 8108.D0/9.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL**2*DLM * ( 128.D0*DM - 16.D0*DP - 96.D0
     &    *X + 304.D0*X**2 - 144.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL**2*DLP * ( 20.D0 - 56.D0*DP - 92.D0*X
     &     - 16.D0*X**2 - 16.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL**2 * (  - 286.D0/3.D0 - 22.D0/3.D0*DM
     &     + 164.D0*X - 302.D0*X**2 + 748.D0/3.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DL**3 * ( 8.D0/3.D0 - 56.D0/3.D0*DM + 16.D
     &    0/3.D0*DP + 16.D0/3.D0*X - 136.D0/3.D0*X**2 + 24.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DLM*S111MX * (  - 512.D0*X - 512.D0*X**2
     &     )
      REGGG2CA2 = REGGG2CA2 + DLM*S11MX * ( 64.D0*DP + 128.D0*X + 64.D0
     &    *X**2 + 64.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DLM*ZETA2 * ( 32.D0*DP + 384.D0*X - 128.D0
     &    *X**2 + 192.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DLM * ( 8108.D0/9.D0 - 8636.D0/9.D0*X +
     &    7576.D0/9.D0*X**2 - 1020.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DLM**2 * (  - 528.D0 + 2032.D0/3.D0*X -
     &    1856.D0/3.D0*X**2 + 1760.D0/3.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DLM**3 * (  - 256.D0*X + 128.D0*X**2 -
     &    128.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DLP*S11MX * (  - 48.D0 + 32.D0*DP + 16.D0
     &    *X - 64.D0*X**2 - 64.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + DLP*ZETA2 * (  - 24.D0 + 16.D0*DP + 8.D0*
     &    X - 32.D0*X**2 - 32.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + S121MX * (  - 16.D0 - 144.D0*DM - 64.D0*
     &    DP - 208.D0*X - 624.D0*X**2 + 112.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + S211MX * (  - 16.D0 - 8.D0*DM + 64.D0*DP
     &     + 672.D0*X + 536.D0*X**2 + 88.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + S12MX * (  - 48.D0 + 32.D0*DP + 16.D0*X
     &     - 64.D0*X**2 - 64.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + S21MX * (  - 8.D0 + 16.D0*DP + 24.D0*X -
     &    64.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + S21Z * (  - 64.D0*DP - 128.D0*X - 64.D0*
     &    X**2 - 64.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + S21MZ * ( 64.D0*DP + 128.D0*X + 64.D0*
     &    X**2 + 64.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + S111MX * (  - 1112.D0/3.D0 - 44.D0/3.D0*
     &    DM + 464.D0/3.D0*X + 548.D0/3.D0*X**2 - 572.D0/3.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + S11MX * (  - 112.D0/3.D0 - 32.D0*X + 56.D0
     &    *X**2 + 88.D0/3.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + ZETA2 * ( 1220.D0/3.D0 - 1156.D0/3.D0*X
     &     + 1016.D0/3.D0*X**2 - 1408.D0/3.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 + ZETA3 * ( 8.D0*DP - 608.D0*X + 320.D0*
CJS      REGGG2CA2 = REGGG2CA2 + ZETA3 * ( 8.D0*DP - 606.D0*X + 320.D0*
     &    X**2 - 352.D0*X**3 )
      REGGG2CA2 = REGGG2CA2 - 16705.D0/27.D0 + 18523.D0/27.D0*X - 19751.
     &    D0/27.D0*X**2 + 7055.D0/9.D0*X**3
C------------------------------------------------------------------------
      REGGG2CATFNF =
     &  + DL2 * (  - 32.D0/3.D0*X + 16.D0/3.D0*X**2 - 16.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + DL1*DL * (  - 32.D0/3.D0*DM + 32.D0/
     &    3.D0*X - 64.D0/3.D0*X**2 + 32.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + DL1*DLM * (  - 128.D0/3.D0*X + 64.D0
     &    /3.D0*X**2 - 64.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + DL1 * (  - 296.D0/9.D0 + 728.D0/9.D0
     &    *X - 568.D0/9.D0*X**2 + 152.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + DL*DLM * (  - 64.D0/3.D0*DM + 64.D0/
     &    3.D0*X - 128.D0/3.D0*X**2 + 64.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + DL * ( 296.D0/9.D0 + 160.D0/9.D0*DM
     &     - 208.D0/3.D0*X + 268.D0/3.D0*X**2 - 64.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + DL**2 * ( 8.D0/3.D0 + 8.D0/3.D0*DM
     &     - 8.D0*X + 20.D0*X**2 - 16.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + DLM * (  - 592.D0/9.D0 + 1456.D0/9.D
     &    0*X - 1160.D0/9.D0*X**2 + 304.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + DLM**2 * (  - 128.D0/3.D0*X + 64.D0/
     &    3.D0*X**2 - 64.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + S121MX * (  - 16.D0 + 16.D0*X - 8.D0
     &    *X**2 )
      REGGG2CATFNF = REGGG2CATFNF + S211MX * (  - 16.D0 + 16.D0*X - 8.D0
     &    *X**2 )
      REGGG2CATFNF = REGGG2CATFNF + S111MX * ( 16.D0/3.D0 + 16.D0/3.D0*
     &    DM - 160.D0/3.D0*X + 8.D0/3.D0*X**2 - 32.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + ZETA2 * ( 128.D0/3.D0*X - 64.D0/3.D0
     &    *X**2 + 64.D0/3.D0*X**3 )
      REGGG2CATFNF = REGGG2CATFNF + 3142.D0/27.D0 - 6188.D0/27.D0*X +
     &    5218.D0/27.D0*X**2 - 3068.D0/27.D0*X**3
C------------------------------------------------------------------------------
      REGGG2CFTFNF =
     &  + DL2*DL * ( 16.D0*X + 16.D0*X**2 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL2 * ( 32.D0/3.D0 + 8.D0*X - 8.D0*
     &    X**2 - 32.D0/3.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL1*DL*DLM * ( 64.D0*X + 64.D0*X**2
     &     )
      REGGG2CFTFNF = REGGG2CFTFNF + DL1*DL * (  - 64.D0/3.D0 - 64.D0*X
     &     - 48.D0*X**2 + 128.D0/3.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL1*DL**2 * (  - 32.D0*X - 32.D0*
     &    X**2 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL1*DLM * ( 128.D0/3.D0 + 32.D0*X
     &     - 32.D0*X**2 - 128.D0/3.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL1*S111MX * ( 64.D0*X + 64.D0*X**2
     &     )
      REGGG2CFTFNF = REGGG2CFTFNF + DL1 * (  - 256.D0/9.D0 - 448.D0/3.D0
     &    *X + 352.D0/3.D0*X**2 + 544.D0/9.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL*DLM * (  - 128.D0/3.D0 - 128.D0*
     &    X - 96.D0*X**2 + 256.D0/3.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL*DLM**2 * ( 64.D0*X + 64.D0*X**2
     &     )
      REGGG2CFTFNF = REGGG2CFTFNF + DL*S111MX * (  - 32.D0*X - 32.D0*
     &    X**2 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL*ZETA2 * (  - 64.D0*X - 64.D0*
     &    X**2 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL * ( 256.D0/9.D0 + 192.D0*X - 128.
     &    D0*X**2 - 1088.D0/9.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL**2*DLM * (  - 64.D0*X - 64.D0*
     &    X**2 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL**2 * ( 32.D0/3.D0 + 52.D0*X + 28.
     &    D0*X**2 - 32.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + DL**3 * ( 40.D0/3.D0*X + 40.D0/3.D0
     &    *X**2 )
      REGGG2CFTFNF = REGGG2CFTFNF + DLM*S111MX * ( 128.D0*X + 128.D0*
     &    X**2 )
      REGGG2CFTFNF = REGGG2CFTFNF + DLM * (  - 512.D0/9.D0 - 896.D0/3.D0
     &    *X + 704.D0/3.D0*X**2 + 1088.D0/9.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + DLM**2 * ( 128.D0/3.D0 + 32.D0*X -
     &    32.D0*X**2 - 128.D0/3.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + S121MX * ( 32.D0 + 32.D0*X + 80.D0*
     &    X**2 )
      REGGG2CFTFNF = REGGG2CFTFNF + S211MX * ( 32.D0 - 160.D0*X - 112.D0
     &    *X**2 )
      REGGG2CFTFNF = REGGG2CFTFNF + S111MX * ( 64.D0/3.D0 - 48.D0*X -
     &    160.D0*X**2 + 64.D0/3.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF + ZETA2 * (  - 128.D0/3.D0 - 32.D0*X
     &     + 32.D0*X**2 + 128.D0/3.D0*X**3 )
      REGGG2CFTFNF = REGGG2CFTFNF - 608.D0/27.D0 + 4144.D0/9.D0*X -
     &    3280.D0/9.D0*X**2 - 1984.D0/27.D0*X**3
      CGG2R=CA**2*REGGG2CA2+CA*TF*NF*REGGG2CATFNF+CF*TF*NF*REGGG2CFTFNF
      IF(MODH.EQ.1) THEN
      CGG2R=CGG2R
      ELSEIF(MODH.EQ.2) THEN
      CGG2R=CGG2R+CA**2*(DL1*( -128.D0*X+64.D0*X**2-64.D0*X**3 )
     & +DL*(32.D0-64.D0*DM+440.D0/3.D0*X-64.D0*X**2+64.D0*X**3 )
     & +DL**2*(-16.D0*X)+DLM*(-256.D0*X+128.D0*X**2-128.D0*X**3 )
     & + 44.D0/3.D0+232.D0/3.D0*X-452.D0/3.D0*X**2+176.D0/3.D0*X**3)
     & + CA*TF*NF*(DL*( 32.D0/3.D0*X )+16.D0/3.D0+16.D0/3.D0*X
     & -32.D0/3.D0*X**2)
     & +CF*TF*NF*( DL**2*(16.D0*X )-16.D0+32.D0*X-16.D0*X**2)
      ENDIF
      RETURN
      END

      DOUBLE PRECISION FUNCTION CGG2SPV(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      COMMON/HIGGSSET/MODE,MODH,MODP
      ZETA2=1.6449340668D0
      ZETA3=1.2020569031D0
      DL1=DLOG(Q2/MU2)
      DL2=DL1*DL1
      DLM=DLOG(1.0D0-X)
      SPVGG2CA2 =
     &  + DL2*ZETA2 * (  - 32.D0 )
      SPVGG2CA2 = SPVGG2CA2 + DL1*ZETA2 * (  - 88.D0/3.D0 )
      SPVGG2CA2 = SPVGG2CA2 + DL1*ZETA3 * ( 152.D0 )
      SPVGG2CA2 = SPVGG2CA2 + DL1 * (  - 24.D0 )
      SPVGG2CA2 = SPVGG2CA2 + ZETA2 * ( 536.D0/9.D0 )
      SPVGG2CA2 = SPVGG2CA2 + ZETA2**2 * (  - 4.D0/5.D0 )
      SPVGG2CA2 = SPVGG2CA2 + ZETA3 * (  - 220.D0/3.D0 )
      SPVGG2CA2 = SPVGG2CA2 + 93.D0
C------------------------------------------------------------------------
      SPVGG2CATFNF =
     &  + DL1*ZETA2 * ( 32.D0/3.D0 )
      SPVGG2CATFNF = SPVGG2CATFNF + DL1 * ( 16.D0 )
      SPVGG2CATFNF = SPVGG2CATFNF + ZETA2 * (  - 160.D0/9.D0 )
      SPVGG2CATFNF = SPVGG2CATFNF + ZETA3 * ( 80.D0/9.D0 )
      SPVGG2CATFNF = SPVGG2CATFNF - 2024.D0/27.D0
C--------------------------------------------------------------------------
      SPVGG2CFTFNF =
     &  + DL1 * ( 8.D0 )
      SPVGG2CFTFNF = SPVGG2CFTFNF + 4.D0
C--------------------------------------------------------------------------
      DLGG2CA2 =
     &  + DL2*DLM * (  - 44.D0/3.D0 )
      DLGG2CA2 = DLGG2CA2 + DL2*DLM**2 * ( 32.D0 )
      DLGG2CA2 = DLGG2CA2 + DL1*DLM*ZETA2 * (  - 80.D0 )
      DLGG2CA2 = DLGG2CA2 + DL1*DLM * ( 536.D0/9.D0 )
      DLGG2CA2 = DLGG2CA2 + DL1*DLM**2 * (  - 88.D0/3.D0 )
      DLGG2CA2 = DLGG2CA2 + DL1*DLM**3 * ( 64.D0 )
      DLGG2CA2 = DLGG2CA2 + DLM*ZETA2 * ( 176.D0/3.D0 )
      DLGG2CA2 = DLGG2CA2 + DLM*ZETA3 * ( 312.D0 )
      DLGG2CA2 = DLGG2CA2 + DLM * (  - 1616.D0/27.D0 )
      DLGG2CA2 = DLGG2CA2 + DLM**2*ZETA2 * ( 80.D0 )
      DLGG2CA2 = DLGG2CA2 + DLM**2 * ( 536.D0/9.D0 )
      DLGG2CA2 = DLGG2CA2 + DLM**3 * (  - 176.D0/9.D0 )
      DLGG2CA2 = DLGG2CA2 + DLM**4 * ( 32.D0 )
C------------------------------------------------------------------------
      DLGG2CATFNF =
     &  + DL2*DLM * ( 16.D0/3.D0 )
      DLGG2CATFNF = DLGG2CATFNF + DL1*DLM * (  - 160.D0/9.D0 )
      DLGG2CATFNF = DLGG2CATFNF + DL1*DLM**2 * ( 32.D0/3.D0 )
      DLGG2CATFNF = DLGG2CATFNF + DLM*ZETA2 * (  - 64.D0/3.D0 )
      DLGG2CATFNF = DLGG2CATFNF + DLM * ( 448.D0/27.D0 )
      DLGG2CATFNF = DLGG2CATFNF + DLM**2 * (  - 160.D0/9.D0 )
      DLGG2CATFNF = DLGG2CATFNF + DLM**3 * ( 64.D0/9.D0 )
      CGG2SPV=CA**2*(SPVGG2CA2+DLGG2CA2)+CA*TF*NF*(SPVGG2CATFNF
     &+DLGG2CATFNF)+CF*TF*NF*SPVGG2CFTFNF
      IF(MODH.EQ.1) THEN
      CGG2SPV=CGG2SPV
      ELSEIF(MODH.EQ.2) THEN
      CGG2SPV=CGG2SPV+CA**2*(DL1*( - 20.D0/3.D0 )+ZETA2*( 64.D0 )
     &+ 215.D0/3.D0+DL1*DLM*( 64.D0 )+DLM**2*( 64.D0 ))
     &+CA*TF*NF*(+DL1*(- 8.D0/3.D0 ) - 196.D0/9.D0)
     &+CF*TF*NF*(DL1 * (- 8.D0) -4.D0)
      ENDIF
      RETURN
      END

      DOUBLE PRECISION FUNCTION CGG2SOFT(X)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      COMMON/HIGGSSET/MODE,MODH,MODP
      ZETA2=1.6449340668D0
      ZETA3=1.2020569031D0
      DL1=DLOG(Q2/MU2)
      DL2=DL1*DL1
      DLM=DLOG(1.0D0-X)
      DM=1.0D0/(1.0D0-X)
      SOFTGG2CA2 =
     &  + DL2*DLM * ( 64.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + DL2 * (  - 44.D0/3.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + DL1*DLM * (  - 176.D0/3.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + DL1*DLM**2 * ( 192.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + DL1*ZETA2 * (  - 80.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + DL1 * ( 536.D0/9.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + DLM*ZETA2 * (  - 160.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + DLM * ( 1072.D0/9.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + DLM**2 * (  - 176.D0/3.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + DLM**3 * ( 128.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + ZETA2 * ( 176.D0/3.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 + ZETA3 * ( 312.D0*DM )
      SOFTGG2CA2 = SOFTGG2CA2 - 1616.D0/27.D0*DM
C-----------------------------------------------------------------------------
      SOFTGG2CATFNF =
     &  + DL2 * ( 16.D0/3.D0*DM )
      SOFTGG2CATFNF = SOFTGG2CATFNF + DL1*DLM * ( 64.D0/3.D0*DM )
      SOFTGG2CATFNF = SOFTGG2CATFNF + DL1 * (  - 160.D0/9.D0*DM )
      SOFTGG2CATFNF = SOFTGG2CATFNF + DLM * (  - 320.D0/9.D0*DM )
      SOFTGG2CATFNF = SOFTGG2CATFNF + DLM**2 * ( 64.D0/3.D0*DM )
      SOFTGG2CATFNF = SOFTGG2CATFNF + ZETA2 * (  - 64.D0/3.D0*DM )
      SOFTGG2CATFNF = SOFTGG2CATFNF + 448.D0/27.D0*DM
      CGG2SOFT=CA**2*SOFTGG2CA2+CA*TF*NF*SOFTGG2CATFNF
      IF(MODH.EQ.1) THEN
      CGG2SOFT=CGG2SOFT
      ELSEIF(MODH.EQ.2) THEN
      CGG2SOFT=CGG2SOFT+CA**2*(DL1*(64.D0*DM)+DLM*(128.D0*DM))
      ENDIF
      RETURN
      END

      DOUBLE PRECISION FUNCTION CQG2(X)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 WGPLG
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      COMMON/HIGGSSET/MODE,MODH,MODP
      ZETA2=1.6449340668D0
      ZETA3=1.2020569031D0
      DL1=DLOG(Q2/MU2)
      DL2=DL1*DL1
      DLM=DLOG(1.0D0-X)
      DL=DLOG(X)
      Z=(1.0D0-X)/(1.0D0+X)
      S21Z=WGPLG(2,1,Z)
      S21MZ=WGPLG(2,1,-Z)
      S121MX=WGPLG(1,2,1.0D0-X)
      S211MX=WGPLG(2,1,1.0D0-X)
      S21MX=WGPLG(2,1,-X)
      S111MX=WGPLG(1,1,1.0D0-X)
      S11MX=WGPLG(1,1,-X)
      DLM=DLOG(1.0D0-X)
      DLP=DLOG(1.0D0+X)
      DL=DLOG(X)
      SQG2CF2 =
     &  + DL2*DL * ( 4.D0*X - 2.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DL2*DLM * ( 8.D0 - 8.D0*X + 4.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DL2 * ( 4.D0*X - X**2 )
      SQG2CF2 = SQG2CF2 + DL1*DL*DLM * (  - 16.D0 + 32.D0*X - 16.D0*
     &    X**2 )
      SQG2CF2 = SQG2CF2 + DL1*DL * (  - 8.D0*X + 38.D0*X**2 + 16.D0/3.D0
     &    *X**3 )
      SQG2CF2 = SQG2CF2 + DL1*DL**2 * (  - 8.D0*X + 4.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DL1*DLM * (  - 36.D0 + 64.D0*X - 28.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DL1*DLM**2 * ( 24.D0 - 24.D0*X + 12.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DL1*S111MX * ( 16.D0 )
      SQG2CF2 = SQG2CF2 + DL1*ZETA2 * (  - 32.D0 + 32.D0*X - 16.D0*X**2
     &     )
      SQG2CF2 = SQG2CF2 + DL1 * ( 106.D0/9.D0 - 12.D0*X - 4.D0*X**2 -
     &    124.D0/9.D0*X**3 )
      SQG2CF2 = SQG2CF2 + DL*DLM * ( 36.D0 - 56.D0*X + 88.D0*X**2 + 32.D
     &    0/3.D0*X**3 )
      SQG2CF2 = SQG2CF2 + DL*DLM**2 * (  - 24.D0 + 40.D0*X - 20.D0*X**2
     &     )
      SQG2CF2 = SQG2CF2 + DL*DLP * ( 32.D0/3.D0 + 16.D0*X + 16.D0*X**2
     &     + 32.D0/3.D0*X**3 )
      SQG2CF2 = SQG2CF2 + DL*S111MX * (  - 16.D0 + 8.D0*X - 4.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DL*ZETA2 * ( 32.D0 - 48.D0*X + 24.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DL * (  - 106.D0/9.D0 + 69.D0*X - 214.D0/3.D0
     &    *X**2 + 112.D0/9.D0*X**3 )
      SQG2CF2 = SQG2CF2 + DL**2*DLM * ( 8.D0 - 24.D0*X + 12.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DL**2 * (  - 14.D0*X - 63.D0/2.D0*X**2 - 40.D0
     &    /3.D0*X**3 )
      SQG2CF2 = SQG2CF2 + DL**3 * ( 10.D0/3.D0*X - 5.D0/3.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DLM*S111MX * ( 16.D0 + 16.D0*X - 8.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DLM*ZETA2 * (  - 64.D0 + 64.D0*X - 32.D0*X**2
     &     )
      SQG2CF2 = SQG2CF2 + DLM * ( 878.D0/9.D0 - 144.D0*X + 48.D0*X**2
     &     - 248.D0/9.D0*X**3 )
      SQG2CF2 = SQG2CF2 + DLM**2 * (  - 60.D0 + 94.D0*X - 45.D0*X**2 )
      SQG2CF2 = SQG2CF2 + DLM**3 * ( 52.D0/3.D0 - 52.D0/3.D0*X + 26.D0/
     &    3.D0*X**2 )
      SQG2CF2 = SQG2CF2 + S121MX * (  - 32.D0 + 48.D0*X - 24.D0*X**2 )
      SQG2CF2 = SQG2CF2 + S211MX * (  - 16.D0 - 16.D0*X + 8.D0*X**2 )
      SQG2CF2 = SQG2CF2 + S111MX * (  - 92.D0/3.D0 + 56.D0*X + 42.D0*
     &    X**2 + 16.D0/3.D0*X**3 )
      SQG2CF2 = SQG2CF2 + S11MX * ( 32.D0/3.D0 + 16.D0*X + 16.D0*X**2
     &     + 32.D0/3.D0*X**3 )
      SQG2CF2 = SQG2CF2 + ZETA2 * ( 232.D0/3.D0 - 104.D0*X + 60.D0*X**2
     &     + 16.D0/3.D0*X**3 )
      SQG2CF2 = SQG2CF2 + ZETA3 * ( 32.D0 - 32.D0*X + 16.D0*X**2 )
      SQG2CF2 = SQG2CF2 - 1393.D0/54.D0 - 130.D0/9.D0*X + 17.D0/18.D0*
     &    X**2 + 1304.D0/27.D0*X**3
C------------------------------------------------------------------------------
      SQG2CACF =
     &  + DL2*DL * (  - 24.D0 - 24.D0*X - 24.D0*X**2 )
      SQG2CACF = SQG2CACF + DL2*DLM * ( 24.D0 - 24.D0*X + 12.D0*X**2 )
      SQG2CACF = SQG2CACF + DL2 * (  - 230.D0/3.D0 + 188.D0/3.D0*X - 4.D
     &    0/3.D0*X**2 + 8.D0*X**3 )
      SQG2CACF = SQG2CACF + DL1*DL*DLM * (  - 128.D0 - 64.D0*X - 112.D0
     &    *X**2 )
      SQG2CACF = SQG2CACF + DL1*DL*DLP * ( 16.D0 + 16.D0*X + 8.D0*X**2
     &     )
      SQG2CACF = SQG2CACF + DL1*DL * ( 124.D0 - 448.D0/3.D0*X + 8.D0/3.D
     &    0*X**2 - 32.D0*X**3 )
      SQG2CACF = SQG2CACF + DL1*DL**2 * ( 24.D0 + 32.D0*X + 28.D0*X**2
     &     )
      SQG2CACF = SQG2CACF + DL1*DLM * (  - 868.D0/3.D0 + 736.D0/3.D0*X
     &     + 40.D0/3.D0*X**2 + 32.D0*X**3 )
      SQG2CACF = SQG2CACF + DL1*DLM**2 * ( 72.D0 - 72.D0*X + 36.D0*X**2
     &     )
      SQG2CACF = SQG2CACF + DL1*S111MX * (  - 48.D0 - 144.D0*X - 72.D0*
     &    X**2 )
      SQG2CACF = SQG2CACF + DL1*S11MX * ( 16.D0 + 16.D0*X + 8.D0*X**2 )
      SQG2CACF = SQG2CACF + DL1*ZETA2 * ( 16.D0*X )
      SQG2CACF = SQG2CACF + DL1 * ( 2422.D0/9.D0 - 1724.D0/9.D0*X - 362.
     &    D0/9.D0*X**2 - 32.D0/9.D0*X**3 )
      SQG2CACF = SQG2CACF + DL*DLM*DLP * ( 32.D0 + 32.D0*X + 16.D0*X**2
     &     )
      SQG2CACF = SQG2CACF + DL*DLM * ( 692.D0/3.D0 - 832.D0/3.D0*X - 40.
     &    D0/3.D0*X**2 - 64.D0*X**3 )
      SQG2CACF = SQG2CACF + DL*DLM**2 * (  - 132.D0 - 60.D0*X - 114.D0*
     &    X**2 )
      SQG2CACF = SQG2CACF + DL*DLP * (  - 88.D0/3.D0 - 40.D0*X - 12.D0*
     &    X**2 - 16.D0/3.D0*X**3 )
      SQG2CACF = SQG2CACF + DL*S111MX * (  - 48.D0 - 32.D0*X - 32.D0*
     &    X**2 )
      SQG2CACF = SQG2CACF + DL*S11MX * (  - 32.D0 - 32.D0*X - 16.D0*
     &    X**2 )
      SQG2CACF = SQG2CACF + DL*ZETA2 * ( 64.D0 + 112.D0*X + 80.D0*X**2
     &     )
      SQG2CACF = SQG2CACF + DL * (  - 2402.D0/9.D0 + 2660.D0/9.D0*X +
     &    1079.D0/9.D0*X**2 + 224.D0/9.D0*X**3 )
      SQG2CACF = SQG2CACF + DL**2*DLM * ( 64.D0 + 48.D0*X + 64.D0*X**2
     &     )
      SQG2CACF = SQG2CACF + DL**2*DLP * (  - 24.D0 - 24.D0*X - 12.D0*
     &    X**2 )
      SQG2CACF = SQG2CACF + DL**2 * (  - 62.D0 + 344.D0/3.D0*X - 10.D0/
     &    3.D0*X**2 + 68.D0/3.D0*X**3 )
      SQG2CACF = SQG2CACF + DL**3 * (  - 8.D0 - 12.D0*X - 10.D0*X**2 )
      SQG2CACF = SQG2CACF + DLM*S111MX * (  - 80.D0 - 304.D0*X - 136.D0
     &    *X**2 )
      SQG2CACF = SQG2CACF + DLM*S11MX * ( 32.D0 + 32.D0*X + 16.D0*X**2
     &     )
      SQG2CACF = SQG2CACF + DLM*ZETA2 * ( 32.D0*X )
      SQG2CACF = SQG2CACF + DLM * ( 4342.D0/9.D0 - 904.D0/3.D0*X - 116.D
     &    0*X**2 - 64.D0/9.D0*X**3 )
      SQG2CACF = SQG2CACF + DLM**2 * (  - 784.D0/3.D0 + 634.D0/3.D0*X
     &     + 97.D0/3.D0*X**2 + 32.D0*X**3 )
      SQG2CACF = SQG2CACF + DLM**3 * ( 140.D0/3.D0 - 140.D0/3.D0*X + 70.
     &    D0/3.D0*X**2 )
      SQG2CACF = SQG2CACF + S121MX * (  - 136.D0 - 248.D0*X - 148.D0*
     &    X**2 )
      SQG2CACF = SQG2CACF + S211MX * ( 104.D0 + 344.D0*X + 148.D0*X**2
     &     )
      SQG2CACF = SQG2CACF + S21MX * ( 16.D0 + 16.D0*X + 8.D0*X**2 )
      SQG2CACF = SQG2CACF + S21Z * (  - 32.D0 - 32.D0*X - 16.D0*X**2 )
      SQG2CACF = SQG2CACF + S21MZ * ( 32.D0 + 32.D0*X + 16.D0*X**2 )
      SQG2CACF = SQG2CACF + S111MX * (  - 538.D0/3.D0 + 40.D0*X + 34.D0
     &    *X**2 - 40.D0/3.D0*X**3 )
      SQG2CACF = SQG2CACF + S11MX * (  - 88.D0/3.D0 - 40.D0*X - 12.D0*
     &    X**2 - 16.D0/3.D0*X**3 )
      SQG2CACF = SQG2CACF + ZETA2 * ( 574.D0/3.D0 - 128.D0*X - 58.D0*
     &    X**2 - 104.D0/3.D0*X**3 )
      SQG2CACF = SQG2CACF + ZETA3 * ( 136.D0 - 112.D0*X + 68.D0*X**2 )
      SQG2CACF = SQG2CACF - 21539.D0/54.D0 + 9962.D0/27.D0*X + 1171.D0/
     &    54.D0*X**2 - 238.D0/27.D0*X**3
C----------------------------------------------------------------------------
      SQG2CFTFNF =
     &  + DL2 * ( 16.D0/3.D0 - 16.D0/3.D0*X + 8.D0/3.D0*X**2 )
      SQG2CFTFNF = SQG2CFTFNF + DL1*DL * (  - 32.D0/3.D0 + 32.D0/3.D0*X
     &     - 16.D0/3.D0*X**2 )
      SQG2CFTFNF = SQG2CFTFNF + DL1*DLM * ( 32.D0/3.D0 - 32.D0/3.D0*X
     &     + 16.D0/3.D0*X**2 )
      SQG2CFTFNF = SQG2CFTFNF + DL1 * (  - 232.D0/9.D0 + 304.D0/9.D0*X
     &     - 152.D0/9.D0*X**2 )
      SQG2CFTFNF = SQG2CFTFNF + DL*DLM * (  - 32.D0/3.D0 + 32.D0/3.D0*X
     &     - 16.D0/3.D0*X**2 )
      SQG2CFTFNF = SQG2CFTFNF + DL * ( 232.D0/9.D0 - 304.D0/9.D0*X +
     &    152.D0/9.D0*X**2 )
      SQG2CFTFNF = SQG2CFTFNF + DL**2 * ( 16.D0/3.D0 - 16.D0/3.D0*X + 8.
     &    D0/3.D0*X**2 )
      SQG2CFTFNF = SQG2CFTFNF + DLM * (  - 104.D0/3.D0 + 128.D0/3.D0*X
     &     - 24.D0*X**2 )
      SQG2CFTFNF = SQG2CFTFNF + DLM**2 * ( 8.D0/3.D0 - 8.D0/3.D0*X + 4.D
     &    0/3.D0*X**2 )
      SQG2CFTFNF = SQG2CFTFNF + 1060.D0/27.D0 - 1672.D0/27.D0*X + 716.D0
     &    /27.D0*X**2
      CQG2=CF**2*SQG2CF2+CA*CF*SQG2CACF+CF*TF*NF*SQG2CFTFNF
      IF(MODH.EQ.1) THEN
      CQG2=CQG2
      ELSEIF(MODH.EQ.2) THEN
      CQG2=CQG2+CF**2*(- 12.D0 + 12.D0*X**2 +DL*(-24.D0*X )
     &+ DL**2 * ( 8.D0*X )-4.D0+16.D0*X-12.D0*X**2)
     &+CA*CF*(DL1*( 32.D0 - 32.D0*X + 16.D0*X**2 ) + DL*( 80.D0*X
     &- 16.D0*X**2 )+DL**2*( -16.D0*X )+DLM*(64.D0-64.D0*X+32.D0*X**2 )
     &+60.D0 - 48.D0*X + 4.D0*X**2)
      ENDIF
      RETURN
      END

      DOUBLE PRECISION FUNCTION CQQB2(X)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 WGPLG
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      COMMON/HIGGSSET/MODE,MODH,MODP
      ZETA2=1.6449340668D0
      ZETA3=1.2020569031D0
      DL1=DLOG(Q2/MU2)
      DL2=DL1*DL1
      DLM=DLOG(1.0D0-X)
      DL=DLOG(X)
      S121MX=WGPLG(1,2,1.0D0-X)
      S12MX=WGPLG(1,2,-X)
      S211MX=WGPLG(2,1,1.0D0-X)
      S21MX=WGPLG(2,1,-X)
      S111MX=WGPLG(1,1,1.0D0-X)
      S11MX=WGPLG(1,1,-X)
      DLM=DLOG(1.0D0-X)
      DLP=DLOG(1.0D0+X)
      DL=DLOG(X)
      SQQBCACF2 =
     &  + DL1 * (  - 88.D0/3.D0 + 88.D0*X - 88.D0*X**2 + 88.D0/3.D0*
     &    X**3 )
      SQQBCACF2 = SQQBCACF2 + DL*DLP * ( 32.D0*X + 16.D0*X**2 + 32.D0/3.
     &    D0*X**3 )
      SQQBCACF2 = SQQBCACF2 + DL*DLP**2 * (  - 16.D0 - 16.D0*X - 8.D0*
     &    X**2 )
      SQQBCACF2 = SQQBCACF2 + DL*S11MX * ( 48.D0 + 48.D0*X + 24.D0*X**2
     &     )
      SQQBCACF2 = SQQBCACF2 + DL * ( 88.D0/3.D0 - 296.D0/3.D0*X + 500.D0
     &    /3.D0*X**2 - 128.D0/3.D0*X**3 )
      SQQBCACF2 = SQQBCACF2 + DL**2*DLP * ( 24.D0 + 24.D0*X + 12.D0*
     &    X**2 )
      SQQBCACF2 = SQQBCACF2 + DL**2 * (  - 40.D0*X - 32.D0/3.D0*X**3 )
      SQQBCACF2 = SQQBCACF2 + DLM * (  - 128.D0/3.D0 + 128.D0*X - 128.D0
     &    *X**2 + 128.D0/3.D0*X**3 )
      SQQBCACF2 = SQQBCACF2 + DLM**2 * ( 32.D0/3.D0 - 32.D0*X + 32.D0*
     &    X**2 - 32.D0/3.D0*X**3 )
      SQQBCACF2 = SQQBCACF2 + DLP*S11MX * (  - 32.D0 - 32.D0*X - 16.D0*
     &    X**2 )
      SQQBCACF2 = SQQBCACF2 + DLP*ZETA2 * (  - 16.D0 - 16.D0*X - 8.D0*
     &    X**2 )
      SQQBCACF2 = SQQBCACF2 + S12MX * (  - 32.D0 - 32.D0*X - 16.D0*X**2
     &     )
      SQQBCACF2 = SQQBCACF2 + S21MX * (  - 48.D0 - 48.D0*X - 24.D0*X**2
     &     )
      SQQBCACF2 = SQQBCACF2 + S111MX * ( 80.D0/3.D0 - 80.D0*X + 80.D0*
     &    X**2 - 80.D0/3.D0*X**3 )
      SQQBCACF2 = SQQBCACF2 + S11MX * ( 32.D0*X + 16.D0*X**2 + 32.D0/3.D
     &    0*X**3 )
      SQQBCACF2 = SQQBCACF2 + ZETA2 * (  - 176.D0/3.D0 + 192.D0*X - 168.
     &    D0*X**2 + 64.D0*X**3 )
      SQQBCACF2 = SQQBCACF2 + ZETA3 * (  - 32.D0 - 32.D0*X - 16.D0*X**2
     &     )
      SQQBCACF2 = SQQBCACF2 + 130.D0 - 316.D0*X + 890.D0/3.D0*X**2 -
     &    332.D0/3.D0*X**3
C----------------------------------------------------------------------------
      SQQBCF3 =
     &  + DL1*DL * ( 32.D0*X - 32.D0*X**2 + 64.D0/3.D0*X**3 )
      SQQBCF3 = SQQBCF3 + DL1*DLM * ( 64.D0/3.D0 - 64.D0*X + 64.D0*X**2
     &     - 64.D0/3.D0*X**3 )
      SQQBCF3 = SQQBCF3 + DL1 * ( 64.D0/3.D0*X - 64.D0/3.D0*X**2 )
      SQQBCF3 = SQQBCF3 + DL*DLM * (  - 64.D0/3.D0 + 96.D0*X - 96.D0*
     &    X**2 + 128.D0/3.D0*X**3 )
      SQQBCF3 = SQQBCF3 + DL*DLP * (  - 64.D0*X - 32.D0*X**2 )
      SQQBCF3 = SQQBCF3 + DL*DLP**2 * ( 32.D0 + 32.D0*X + 16.D0*X**2 )
      SQQBCF3 = SQQBCF3 + DL*S11MX * (  - 96.D0 - 96.D0*X - 48.D0*X**2
     &     )
      SQQBCF3 = SQQBCF3 + DL * (  - 256.D0/3.D0*X - 200.D0/3.D0*X**2 -
     &    32.D0*X**3 )
      SQQBCF3 = SQQBCF3 + DL**2*DLP * (  - 48.D0 - 48.D0*X - 24.D0*X**2
     &     )
      SQQBCF3 = SQQBCF3 + DL**2 * ( 40.D0*X + 48.D0*X**2 - 16.D0/3.D0*
     &    X**3 )
      SQQBCF3 = SQQBCF3 + DLM * (  - 32.D0 + 352.D0/3.D0*X - 352.D0/3.D0
     &    *X**2 + 32.D0*X**3 )
      SQQBCF3 = SQQBCF3 + DLM**2 * ( 32.D0/3.D0 - 32.D0*X + 32.D0*X**2
     &     - 32.D0/3.D0*X**3 )
      SQQBCF3 = SQQBCF3 + DLP*S11MX * ( 64.D0 + 64.D0*X + 32.D0*X**2 )
      SQQBCF3 = SQQBCF3 + DLP*ZETA2 * ( 32.D0 + 32.D0*X + 16.D0*X**2 )
      SQQBCF3 = SQQBCF3 + S12MX * ( 64.D0 + 64.D0*X + 32.D0*X**2 )
      SQQBCF3 = SQQBCF3 + S21MX * ( 96.D0 + 96.D0*X + 48.D0*X**2 )
      SQQBCF3 = SQQBCF3 + S111MX * (  - 32.D0 + 128.D0*X - 128.D0*X**2
     &     + 160.D0/3.D0*X**3 )
      SQQBCF3 = SQQBCF3 + S11MX * (  - 64.D0*X - 32.D0*X**2 )
      SQQBCF3 = SQQBCF3 + ZETA2 * ( 224.D0/3.D0 - 256.D0*X + 208.D0*
     &    X**2 - 224.D0/3.D0*X**3 )
      SQQBCF3 = SQQBCF3 + ZETA3 * ( 64.D0 + 64.D0*X + 32.D0*X**2 )
      SQQBCF3 = SQQBCF3 - 164.D0/3.D0 - 64.D0*X + 260.D0/3.D0*X**2 + 32.
     &    D0*X**3
C-----------------------------------------------------------------------------
      SQQBCF2 =
     &  + DL2*DL * (  - 16.D0 - 16.D0*X - 4.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL2 * (  - 24.D0 + 16.D0*X + 8.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL1*DL*DLM * (  - 64.D0 - 64.D0*X - 16.D0*
     &    X**2 )
      SQQBCF2 = SQQBCF2 + DL1*DL * ( 48.D0 - 32.D0*X - 20.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL1*DL**2 * ( 16.D0 + 16.D0*X + 4.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL1*DLM * (  - 96.D0 + 64.D0*X + 32.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL1*S111MX * (  - 64.D0 - 64.D0*X - 16.D0*
     &    X**2 )
      SQQBCF2 = SQQBCF2 + DL1 * ( 102.D0 - 72.D0*X - 30.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL*DLM * ( 96.D0 - 64.D0*X - 40.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL*DLM**2 * (  - 64.D0 - 64.D0*X - 16.D0*X**2
     &     )
      SQQBCF2 = SQQBCF2 + DL*S111MX * (  - 32.D0 - 32.D0*X - 8.D0*X**2
     &     )
      SQQBCF2 = SQQBCF2 + DL*ZETA2 * ( 64.D0 + 64.D0*X + 16.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL * (  - 118.D0 + 88.D0*X + 58.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL**2*DLM * ( 32.D0 + 32.D0*X + 8.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL**2 * (  - 24.D0 + 32.D0*X + 8.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DL**3 * (  - 16.D0/3.D0 - 16.D0/3.D0*X - 4.D0/
     &    3.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DLM*S111MX * (  - 128.D0 - 128.D0*X - 32.D0*
     &    X**2 )
      SQQBCF2 = SQQBCF2 + DLM * ( 204.D0 - 144.D0*X - 60.D0*X**2 )
      SQQBCF2 = SQQBCF2 + DLM**2 * (  - 96.D0 + 64.D0*X + 32.D0*X**2 )
      SQQBCF2 = SQQBCF2 + S121MX * (  - 128.D0 - 128.D0*X - 32.D0*X**2
     &     )
      SQQBCF2 = SQQBCF2 + S211MX * ( 128.D0 + 128.D0*X + 32.D0*X**2 )
      SQQBCF2 = SQQBCF2 + S111MX * (  - 48.D0 + 32.D0*X + 8.D0*X**2 )
      SQQBCF2 = SQQBCF2 + ZETA2 * ( 96.D0 - 64.D0*X - 32.D0*X**2 )
      SQQBCF2 = SQQBCF2 - 210.D0 + 188.D0*X + 22.D0*X**2
C--------------------------------------------------------------------------
      SQQBCF2TFNF =
     &  + DL1 * ( 32.D0/3.D0 - 32.D0*X + 32.D0*X**2 - 32.D0/3.D0*X**3 )
      SQQBCF2TFNF = SQQBCF2TFNF + DL * (  - 32.D0/3.D0 + 160.D0/3.D0*X
     &     - 128.D0/3.D0*X**2 + 128.D0/9.D0*X**3 )
      SQQBCF2TFNF = SQQBCF2TFNF + DLM * ( 64.D0/9.D0 - 64.D0/3.D0*X +
     &    64.D0/3.D0*X**2 - 64.D0/9.D0*X**3 )
      SQQBCF2TFNF = SQQBCF2TFNF - 368.D0/27.D0 + 592.D0/9.D0*X - 688.D0/
     &    9.D0*X**2 + 656.D0/27.D0*X**3
      CQQB2=CA*CF**2*SQQBCACF2+CF**3*SQQBCF3+CF**2*SQQBCF2
     &+CF**2*TF*NF*SQQBCF2TFNF
      IF(MODH.EQ.1) THEN
      CQQB2=CQQB2
      ELSEIF(MODH.EQ.2) THEN
      CQQB2=CQQB2+CA*CF**2*(DL*( 80.D0/3.D0*X )+DL**2*( 16.D0*X )
     &+8.D0/3.D0 + 56.D0/3.D0*X**2 - 64.D0/3.D0*X**3)
     &+CF**3*( - 48.D0 + 96.D0*X - 48.D0*X**2  + DL * (  - 32.D0*X )
     &+ DL**2 * (  - 16.D0*X )+64.D0 - 160.D0*X + 96.D0*X**2)
     &+CF**2*(+DL*( 32.D0 + 48.D0*X )+DL**2 * (  - 16.D0*X )
     & + 88.D0 - 96.D0*X + 8.D0*X**2)
     & +CF**2*TF*NF*( DL *(-64.D0/3.D0*X )-32.D0/3.D0+32.D0/3.D0*X**2)
      ENDIF
      RETURN
      END


      DOUBLE PRECISION FUNCTION CQ1Q22(X)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 WGPLG
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      COMMON/HIGGSSET/MODE,MODH,MODP
      ZETA2=1.6449340668D0
      DL1=DLOG(Q2/MU2)
      DL2=DL1*DL1
      DLM=DLOG(1.0D0-X)
      DL=DLOG(X)
      S121MX=WGPLG(1,2,1.0D0-X)
      S211MX=WGPLG(2,1,1.0D0-X)
      S111MX=WGPLG(1,1,1.0D0-X)
      DLM=DLOG(1.0D0-X)
      DL=DLOG(X)
      SQ1Q2CF2 =
     &  + DL2*DL * (  - 16.D0 - 16.D0*X - 4.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL2 * (  - 24.D0 + 16.D0*X + 8.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL1*DL*DLM * (  - 64.D0 - 64.D0*X - 16.D0*
     &    X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL1*DL * ( 48.D0 - 32.D0*X - 20.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL1*DL**2 * ( 16.D0 + 16.D0*X + 4.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL1*DLM * (  - 96.D0 + 64.D0*X + 32.D0*X**2
     &     )
      SQ1Q2CF2 = SQ1Q2CF2 + DL1*S111MX * (  - 64.D0 - 64.D0*X - 16.D0*
     &    X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL1 * ( 102.D0 - 72.D0*X - 30.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL*DLM * ( 96.D0 - 64.D0*X - 40.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL*DLM**2 * (  - 64.D0 - 64.D0*X - 16.D0*
     &    X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL*S111MX * (  - 32.D0 - 32.D0*X - 8.D0*
     &    X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL*ZETA2 * ( 64.D0 + 64.D0*X + 16.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL * (  - 118.D0 + 88.D0*X + 58.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL**2*DLM * ( 32.D0 + 32.D0*X + 8.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL**2 * (  - 24.D0 + 32.D0*X + 8.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DL**3 * (  - 16.D0/3.D0 - 16.D0/3.D0*X - 4.D
     &    0/3.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DLM*S111MX * (  - 128.D0 - 128.D0*X - 32.D0
     &    *X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DLM * ( 204.D0 - 144.D0*X - 60.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + DLM**2 * (  - 96.D0 + 64.D0*X + 32.D0*X**2
     &     )
      SQ1Q2CF2 = SQ1Q2CF2 + S121MX * (  - 128.D0 - 128.D0*X - 32.D0*
     &    X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + S211MX * ( 128.D0 + 128.D0*X + 32.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + S111MX * (  - 48.D0 + 32.D0*X + 8.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 + ZETA2 * ( 96.D0 - 64.D0*X - 32.D0*X**2 )
      SQ1Q2CF2 = SQ1Q2CF2 - 210.D0 + 188.D0*X + 22.D0*X**2
      CQ1Q22=CF**2*SQ1Q2CF2
      IF(MODH.EQ.1) THEN
      CQ1Q22=CQ1Q22
      ELSEIF(MODH.EQ.2) THEN
      CQ1Q22=CQ1Q22+CF**2*(DL*( 32.D0+48.D0*X )+DL**2*(- 16.D0*X )
     & + 88.D0 - 96.D0*X + 8.D0*X**2)
      ENDIF
      RETURN
      END


      DOUBLE PRECISION FUNCTION CQQ2(X)
      IMPLICIT REAL*8(A-H,O-Z)
      COMPLEX*16 WGPLG
      REAL*8 NF,MU,MU2
      COMMON/PAR/XX,Q2,MU,MU2
      COMMON/COLOR/CA,CF,TF,NF
      COMMON/HIGGSSET/MODE,MODH,MODP
      ZETA2=1.6449340668D0
      DL1=DLOG(Q2/MU2)
      DL2=DL1*DL1
      DLM=DLOG(1.0D0-X)
      DL=DLOG(X)
      S121MX=WGPLG(1,2,1.0D0-X)
      S211MX=WGPLG(2,1,1.0D0-X)
      S111MX=WGPLG(1,1,1.0D0-X)
      DLM=DLOG(1.0D0-X)
      DL=DLOG(X)
      SQQCACF2 =
     &  + DL * (  - 16.D0*X - 36.D0*X**2 )
      SQQCACF2 = SQQCACF2 + DL**2 * ( 8.D0*X + 12.D0*X**2 )
      SQQCACF2 = SQQCACF2 + S121MX * (  - 16.D0 + 16.D0*X - 8.D0*X**2 )
      SQQCACF2 = SQQCACF2 - 10.D0 - 32.D0*X + 42.D0*X**2
C--------------------------------------------------------------------------
      SQQCF3 =
     &  + DL * ( 32.D0*X + 72.D0*X**2 )
      SQQCF3 = SQQCF3 + DL**2 * (  - 16.D0*X - 24.D0*X**2 )
      SQQCF3 = SQQCF3 + S121MX * ( 32.D0 - 32.D0*X + 16.D0*X**2 )
      SQQCF3 = SQQCF3 + 20.D0 + 64.D0*X - 84.D0*X**2
C---------------------------------------------------------------------------
      SQQCF2 =
     &  + DL2*DL * (  - 16.D0 - 16.D0*X - 4.D0*X**2 )
      SQQCF2 = SQQCF2 + DL2 * (  - 24.D0 + 16.D0*X + 8.D0*X**2 )
      SQQCF2 = SQQCF2 + DL1*DL*DLM * (  - 64.D0 - 64.D0*X - 16.D0*X**2
     &     )
      SQQCF2 = SQQCF2 + DL1*DL * ( 48.D0 - 32.D0*X - 20.D0*X**2 )
      SQQCF2 = SQQCF2 + DL1*DL**2 * ( 16.D0 + 16.D0*X + 4.D0*X**2 )
      SQQCF2 = SQQCF2 + DL1*DLM * (  - 96.D0 + 64.D0*X + 32.D0*X**2 )
      SQQCF2 = SQQCF2 + DL1*S111MX * (  - 64.D0 - 64.D0*X - 16.D0*X**2
     &     )
      SQQCF2 = SQQCF2 + DL1 * ( 102.D0 - 72.D0*X - 30.D0*X**2 )
      SQQCF2 = SQQCF2 + DL*DLM * ( 96.D0 - 64.D0*X - 40.D0*X**2 )
      SQQCF2 = SQQCF2 + DL*DLM**2 * (  - 64.D0 - 64.D0*X - 16.D0*X**2 )
      SQQCF2 = SQQCF2 + DL*S111MX * (  - 32.D0 - 32.D0*X - 8.D0*X**2 )
      SQQCF2 = SQQCF2 + DL*ZETA2 * ( 64.D0 + 64.D0*X + 16.D0*X**2 )
      SQQCF2 = SQQCF2 + DL * (  - 118.D0 + 88.D0*X + 58.D0*X**2 )
      SQQCF2 = SQQCF2 + DL**2*DLM * ( 32.D0 + 32.D0*X + 8.D0*X**2 )
      SQQCF2 = SQQCF2 + DL**2 * (  - 24.D0 + 32.D0*X + 8.D0*X**2 )
      SQQCF2 = SQQCF2 + DL**3 * (  - 16.D0/3.D0 - 16.D0/3.D0*X - 4.D0/3.
     &    D0*X**2 )
      SQQCF2 = SQQCF2 + DLM*S111MX * (  - 128.D0 - 128.D0*X - 32.D0*
     &    X**2 )
      SQQCF2 = SQQCF2 + DLM * ( 204.D0 - 144.D0*X - 60.D0*X**2 )
      SQQCF2 = SQQCF2 + DLM**2 * (  - 96.D0 + 64.D0*X + 32.D0*X**2 )
      SQQCF2 = SQQCF2 + S121MX * (  - 128.D0 - 128.D0*X - 32.D0*X**2 )
      SQQCF2 = SQQCF2 + S211MX * ( 128.D0 + 128.D0*X + 32.D0*X**2 )
      SQQCF2 = SQQCF2 + S111MX * (  - 48.D0 + 32.D0*X + 8.D0*X**2 )
      SQQCF2 = SQQCF2 + ZETA2 * ( 96.D0 - 64.D0*X - 32.D0*X**2 )
      SQQCF2 = SQQCF2 - 210.D0 + 188.D0*X + 22.D0*X**2
      CQQ2=CA*CF**2*SQQCACF2+CF**3*SQQCF3+CF**2*SQQCF2
      IF(MODH.EQ.1) THEN
      CQQ2=CQQ2
      ELSEIF(MODH.EQ.2) THEN
      CQQ2=CQQ2+CA*CF**2*( DL*( 32.D0*X )+DL**2*(-16.D0*X)
     & +32.D0-32.D0*X)
     & +CF**3*(DL*( - 64.D0*X )+DL**2*( 32.D0*X )-64.D0+64.D0*X)
     & +CF**2*(DL*( 32.D0 + 48.D0*X )+DL**2*(- 16.D0*X )
     & +88.D0 - 96.D0*X + 8.D0*X**2)
      ENDIF
      RETURN
      END



C THE ONE-LOOP RUNNING COUPLING CONSTANT

      REAL*8 FUNCTION ALFAS1(RS,LAMBDA,NF)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,LAMBD2,NF
      PI=3.14159265359D0
      LAMBD2=LAMBDA*LAMBDA
      BF=(33.0D0-2.0D0*NF)/12.0D0/PI
      RS2=RS*RS
      DL1=DLOG(RS2/LAMBD2)
      ALFAS1=1.0D0/DL1/BF
      RETURN
      END

C THE TWO-LOOP RUNNING COUPLING CONSTANT

      REAL*8 FUNCTION ALFAS2(RS,LAMBDA,NF)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,LAMBD2,NF
      PI=3.14159265359D0
      LAMBD2=LAMBDA*LAMBDA
      BF=(33.0D0-2.0D0*NF)/12.0D0/PI
      BFP=(153.0D0-19.0D0*NF)/(66.0D0-4.0D0*NF)/PI
      RS2=RS*RS
      DL1=DLOG(RS2/LAMBD2)
      DL2=DLOG(DL1)
      ALFAS2=(1.0D0-(BFP*DL2)/(BF*DL1))/DL1/BF
      RETURN
      END

C THE THREE-LOOP RUNNING COUPLING CONSTANT

      REAL*8 FUNCTION ALFAS3(RS,LAMBDA,NFL)
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*8 LAMBDA,NFL

      include 'CONSTCOM.'

      PI=3.14159265359D0
      AL=2.0D0*DLOG(RS/LAMBDA)
      AL2=AL*AL
      AL3=AL2*AL
      BETA0=(11-2.0D0*NFL/3.0D0)/4.0D0
      BETA02=BETA0*BETA0
      BETA03=BETA02*BETA0
      B1=(102.0D0-38.0D0*NFL/3.0D0)/BETA0/16.0D0
      B2=(2857.0D0/2.0D0-5033.0D0*NFL/18.0D0
     1+325.0D0*NFL*NFL/54.0D0)/BETA0/64.0D0
      ALFAS3=PI*(1.0D0/BETA0/AL-B1*DLOG(AL)/BETA02/AL2
     2+(B1*B1*(DLOG(AL)**2.0D0-DLOG(AL)-1.0D0)+B2)
     3/BETA03/AL3)

!  Take the 5-flavour \alpha_s -- the variation of the scale is 
!  taken into account in the grid therefore turn it back at this place 
 
      q2=scale**2
      alfas3=xqg(0,0.1d0,rs**2/rscale,2)

      RETURN
      END



