      real*8 function useralphas(q2,kschemepdf,kordpdf)
      implicit real*8 (a-h,o-z)

!  Must returns the value of strong coupling at the scale of q2
!  for the 3-flavour scheme (kschemepdf=0), 
!  for the 4-flavour scheme (kschemepdf=1), or 
!  for the 5-flavour scheme (kschemepdf=2) 

!  kordpdf=0  --  LO
!  kordpdf=1  --  NLO
!  kordpdf=2  --  NNLO

      useralphas=1./log(q2/0.04)

      return 
      end      
!------------------------
      real*8 function userpdfs(xb,q2,iq,kschemepdf,kordpdf)
      implicit real*8 (a-h,o-z)

!  Must return the value of PDFs times xb at the scale of q2
!  for the 3-flavour scheme (kschemepdf=0), 
!  for the 4-flavour scheme (kschemepdf=1), or 
!  for the 5-flavour scheme (kschemepdf=2) 

!  kordpdf=0  --  LO
!  kordpdf=1  --  NLO
!  kordpdf=2  --  NNLO
 
!  iq=0 -- gluon
!  iq=1 -- d-quark
!  iq=-1 -- antid-quark
!  iq=2 -- u-quark
!  iq=-2 -- antiu-quark
!  iq=3 -- s-quark
!  iq=-3 -- antis-quark
!  iq=4 -- c-quark
!  iq=-4 -- antic-quark
!  iq=5 -- b-quark
!  iq=-5 -- antib-quark

      userpdfs=xb**(-0.2)*(1-xb)**5.

      return 
      end
